#!/usr/bin/perl
#$Id: index.cgi 4797 2012-05-20 19:06:33Z pro $ $URL: svn://svn.setun.net/search/trunk/web/index.cgi $

=copyright
PRO-search client and web interface
Copyright (C) 2003-2011 Oleg Alexeenkov http://pro.setun.net/search/ proler@gmail.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
=cut

package psindex;
use strict;
use utf8;
#use open ':utf8';
#use open qw(:utf8 :std);
#use encoding "utf8", STDOUT => "utf8", STDIN => "utf8", STDERR => "utf8";
#use encoding 'utf-8';
use Encode;
use Net::Ping;
#eval {
use Time::HiRes qw(time);
#};
#use locale;
#use POSIX 'locale_h';
use Data::Dumper;    #dev only
$Data::Dumper::Sortkeys = 1;
no warnings qw(uninitialized);
our ( %config, %work, %stat, %static, );    #%out,%human, %processor $param,
#BEGIN { print "Content-type: text/html\n\n", '<?xml version="1.0"?><!DOCTYPE html><html>1' if defined($ENV{'SERVER_PORT'}); }# for web dev debug
#print "Content-type: text/html\n\n", '<?xml version="1.0"?><!DOCTYPE html><html>2' if defined($ENV{'SERVER_PORT'}); # for web dev debug
#*psindex::stat = *main::stat;
#*psindex::config = *main::config;
#*psindex::config = *main::out;
*stat   = *main::stat;
*work   = *main::work;
*config = *main::config;
#our $root_path;
#use lib::abs qw(../lib);
use lib::abs qw(../lib);                    #./lib
#BEGIN {
#  ( $ENV{'SCRIPT_FILENAME'} || $0 ) =~ m|^(.+)[/\\].+?$|;    #v0w
#  $root_path = $1 . '/' if $1;
#  $root_path =~ s|\\|/|g;
#print "\n\nuselib[$root_path] ", Dumper(\@INC);
#  eval "use lib '$root_path'" if $root_path;
#  eval "use lib '$root_path../lib'; use psmisc; use psweb; use pssql;";
#  print( "Content-type: text/html\n\n", " lib load error rp=$root_path o=$0 sf=$ENV{'SCRIPT_FILENAME'}; ", $@ ), exit if $@;
#}
use psmisc qw(:all);
use psweb;
use pssql;
#print Dumper(\%INC);
#print Dumper(\%{main::});
sub getcount {    #v1
  my $uri = $config{'counter_url'} || $ENV{'SERVER_NAME'} . $ENV{'SCRIPT_NAME'};
  my %counts;
  open( COUNT, '>>', $config{'count_file'} ), close(COUNT) if !-e $config{'count_file'};
  open( COUNT, '+<', $config{'count_file'} ) or return {};
  flock( COUNT, 2 );
  my ( $day, $pday ) = ( ( localtime( time() ) )[7], ( localtime( time() - 86400 ) )[7] );
  while (<COUNT>) {
    my ( $file, $total, $days ) = /^([^\:]+)\:([^\:]+)\:?(.*)\s*$/;
    $counts{$file}{'total'} = ( $total or next );
    my %d = $days =~ /(\S+)=(\S+)/g;
    $counts{$file}{'day'}  = $d{$day};
    $counts{$file}{'pday'} = $d{$pday};
  }
  ++$counts{$uri}{'total'};
  ++$counts{$uri}{'day'};
  seek( COUNT, 0, 0 );
  foreach ( keys %counts ) {
    next unless $counts{$_}{'total'};
    print COUNT$_, ':', $counts{$_}{'total'}, ':', ( $counts{$_}{'day'} ? $day . '=' . $counts{$_}{'day'} : '' ), ' ',
      ( $counts{$_}{'pday'} ? $pday . '=' . $counts{$_}{'pday'} : '' ), "\n";
  }
  print COUNT"\n\n            \n";
  close(COUNT);
  #flock( COUNT, 8 );
  return $counts{$uri};
}

sub toggle_play {
  my ($row) = @_;
  my $go = $_[0]->{'go'} || $_[0]->{'full'};
  !$_[0]->{'cp'} || $_[0]->{'cp'} eq 'utf-8' ? 1 : eval { $go = Encode::encode $_[0]->{'cp'}, $go };
  return
    #'alert("', ($config{'exts'}{ lc( $row->{'ext'} ) }{'new_win'} .':'. $work{'player_new_win'}), '");',
    'toggle_play(\'' . $row->{'n'} . '\',\'' . encode_url_link(    #$row->{'full'}
    $go
      #scalar cp_trans( $work{'codepage'}, $row->{'cp'}, $row->{'full'} )
    )
    . '\', \''
    . $config{'exts'}{ lc( $row->{'ext'} ) }{'type'} . '\', '
    . ( $config{'exts'}{ lc( $row->{'ext'} ) }{'destroy'}   or 0 ) . ','
    . ( $config{'exts'}{ lc( $row->{'ext'} ) }{'autoclose'} or 0 ) . ','
    . ( ( $config{'exts'}{ lc( $row->{'ext'} ) }{'new_win'} and $work{'player_new_win'} ) or 0 ) . ')';
}

sub ipre_calc_once {
  my ($param) = @_;
  psmisc::lib_init();
#'database'}     = $config{'sql_base_web'};
#$config{'allow_auto_repair'} =
#$config{'sql_reconnect_sleep'} =
#$config{'sql_error_sleep'} =
#$config{'sql_error_tries'} = 0;
#$config{'sql_reconnect_tries'} = 1;
#$config{'sql_dbi_force'}       = 1;
#$config{'sql'}{'database'}     = $config{'sql_base_web'};
#$static{'db'} ||= pssql->new(    'codepage' => $config{'cp_db'},    %{ $config{'sql'} or {} }, %{ $config{'sql_web'} or {} }, 'database' => $config{'sql_base_web'},  );
  $static{'db'} = $static{'dbp'}{ $ENV{'SCRIPT_FILENAME'} } ||= pssql->new(
    'codepage' => $config{'cp_db'},
    %{ $config{'sql'} or {} }, %{ $config{'sql_web'} or {} }, 'database' => $config{'sql_base_web'},
  );
  $static{'db_up'} = $static{'dbp_up'}{ $ENV{'SCRIPT_FILENAME'} } ||=
    ( ref $config{'sql_base_up'} eq 'HASH' ? $config{'sql_base_up'}{'database'} : $config{'sql_base_up'} ) eq
    $static{'db'}{'database'} ? $static{'db'} : pssql->new(
    'codepage' => $config{'cp_db'},
    %{ $config{'sql'} || {} }, %{ $config{'sql_web'} || {} },
    #'database' => ref $config{'sql_base_up'} eq 'HASH' ? $config{'sql_base_up'}{'database'} : $config{'sql_base_up'},
    ref $config{'sql_base_up'} eq 'HASH' ? %{ $config{'sql_base_up'} } : ( 'database' => $config{'sql_base_up'} ),
    );
  $static{'dbs_up'} = [
    ( $config{'no_double_update'} ? () : ( $static{'db'} ) ),
    (
      ( ref $config{'sql_base_up'} eq 'HASH' ? $config{'sql_base_up'}{'database'} : $config{'sql_base_up'} ) eq
        $static{'db'}{'database'} and !$config{'no_double_update'}
      ) ? () : ( $static{'db_up'} )
  ];
  $static{'dbs_up_all'} = [
    $static{'db'}, (
      ( ref $config{'sql_base_up'} eq 'HASH' ? $config{'sql_base_up'}{'database'} : $config{'sql_base_up'} ) eq
        $static{'db'}{'database'} and !$config{'no_double_update'}
      ) ? () : ( $static{'db_up'} )
  ];
  $static{'db'}{'use_sphinx'} = 1,
    $static{'db'}{'sphinx_dbi'} = $static{'db_sphinx'} = $static{'dbp_sphinx'}{ $ENV{'SCRIPT_FILENAME'} } ||= pssql->new(
    'codepage' => $config{'cp_db'},
    %{ $config{'sql'} || {} },
    #'shard'=>undef,
    %{ $config{'sql_sphinx'} || {} }, 'driver' => 'sphinx',
    #'database' => $config{'sql_base_web'},
    ) if $config{'use_sphinx'};
  if ( psmisc::is_hash $config{'sql'}{'shard'} ) {
    for ( keys %{ $config{'sql'}{'shard'} } ) {
      $static{'db'}{'shard_dbis'}{$_} = $static{'dbp_shard'}{$_}{ $ENV{'SCRIPT_FILENAME'} } ||=
        $config{'sql'}{'shard'}{$_} eq '1' ? $static{'db'} : pssql->new(
        'codepage' => $config{'cp_db'},
        %{ $config{'sql'} || {} },
        psmisc::is_hash $config{'sql'}{'shard'}{$_}
        ? %{ $config{'sql'}{'shard'}{$_} }
        : ( 'database' => $config{'sql'}{'shard'}{$_} ),
        #%{$config{'sql'}{'shard'}{$_}},
        %{ $config{'sql'}{'shard_param'}{$_} || {} }
        );
    }
  }
  #print Dumper($static{'dbs_up'});
  #todo
  #( @{ $config{'dbi_err_connection'} }, @{ $config{'dbi_err_fatal'} }, @{ $config{'dbi_err_repair'} } ) = ();
  #
  $config{'action'}{'download'} ||= {
    '1' => sub {
      return if $config{ 'no_download_' . $_[1]->{'prot'} . '_' . $config{'client'} };
      return ( $_[1]->{'size'} and ${ $_[0] } =~ m|^[^:]+\:\/\/.+\/[^\/]+$| );
      }
  };
  #
  $config{'action'}{'goto'} ||= {
    '1' => sub {
      return if $config{ 'no_goto_' . $_[1]->{'prot'} . '_' . $config{'client'} };
      return ( !$config{'scanner'}{ $_[1]->{'prot'} }{'disable_goto'}
          and ( ${ $_[0] } =~ m|/$| or ${ $_[0] } =~ m|^\w+://[^/]+$| or !$_[1]->{'size'} or ${ $_[0] } =~ s|[^/]+$|| ) );
      }
  };
  $config{'action_func'}{'gotoip'} ||= sub {
    my ($row) = @_;
    return
      unless $row->{'ip'}
        and $row->{'ip'} ne $row->{'host'}
        and length( $row->{'path'} ) <= 1
        and !length( $row->{'name'} )
        and !hconfig( 'no_ip', %$row );
#return unless ( !$config{'no_player'} and $row->{'size'} and $row->{'can_show'} );
#print $config{'html_res_play_link_bef'} . '<a class="res_play_link" ', nameid( 'res_play_link' . $row->{'n'} ),      ' href="#" onclick="', toggle_play($row), ';return false;">', lang('show'), '</a>';
#print "[$row->{'prot'}]";
    print $config{'redirector'}->( {
        #'goparam' => {
        #'view' => $row->{'ip'},
        #'url'  => join_url( { map { $_ => $row->{$_} } qw(prot user pass host port dcuser) } ) . '/TTH/' . $row->{'tiger'},
        #'filename' => join_url( { map { $_ => $row->{$_} } qw(name ext) } ),
        #encode_url("$row->{'name'}.$row->{'ext'}"),
        #'size' => $row->{'size'},
        #},
        'go'      => join_url( { %$row, 'host' => $row->{'ip'} } ),
        'actname' => $row->{'ip'},
        'save'    => $row->{'full'},
        ( ( $row->{'prot'} eq 'dchub' ) ? ( 'goparams' => { 'href' => undef }, ) : () ),
        #'goparamsl'=>{'destroy'=>1},
      }
    );
  };
  #print " $row->{'ip'}" ;
  #
  $config{'action_func'}{'show'} ||= sub {
    my ($row) = @_;
    return unless ( !$config{'no_player'} and $row->{'size'} and $row->{'can_show'} );
    print $config{'html_res_play_link_bef'} . '<a class="res_play_link" ', nameid( 'res_play_link' . $row->{'n'} ),
      ' href="#" onclick="', toggle_play($row), ';return false;">', lang('show'), '</a>';
  };
  #
  $config{'action'}{'magnet'} ||= {
    '1' => sub {
      return (
              $_[1]->{'size'}
          and $_[1]->{'tiger'}
          and ${ $_[0] } =
            'magnet:?xt=urn:tree:tiger:'
          . $_[1]->{'tiger'}
          . '&amp;xl='
          . $_[1]->{'size'}
          . '&amp;dn='
          #. encode_url( scalar cp_trans( $work{'codepage'}, 'utf-8', "$_[1]->{'name'}.$_[1]->{'ext'}" ) )
          . encode_url("$_[1]->{'name'}.$_[1]->{'ext'}")
          . '&amp;xs='
          . encode_url( join_url( { map { $_ => $_[1]->{$_} } qw(prot host hostport ) } ) )
      );
    },
  };
  $config{'action_func'}{'magnet'} ||= sub {
    my ($row) = @_;
    return unless $row->{'magnet'};
    print $config{'redirector'}
      ->( { 'go' => $row->{'magnet'}, 'save' => $row->{'magnet'}, 'actname' => lang('magnet'), %$row } );
  };
  $config{'action_func'}{'dcdl'} ||= sub {    #del?
    my ($row) = @_;
    return
      unless ( $config{'allow_proxy'}
      and $row->{'prot'} eq 'dchub'
      and $row->{'size'}
      and $row->{'tiger'}
      and ( $row->{'dcuser'} or $row->{'host'} =~ m|.+/.+| )
      and $row->{'ip'} =~ /$config{'proxy_server_mask'}/i
      and $config{'client_ip'} =~ /$config{'proxy_client_mask'}/i
      and ( $row->{'name'} or $row->{'ext'} ) );
    print $config{'redirector'}->( {
        'goparam' => {
          'view' => 'proxy',
          'url'  => join_url( { map { $_ => $row->{$_} } qw(prot user pass host port dcuser) } ) . '/TTH/' . $row->{'tiger'},
          'filename' => join_url( { map { $_ => $row->{$_} } qw(name ext) } ),
          #encode_url("$row->{'name'}.$row->{'ext'}"),
          'size' => $row->{'size'},
        },
        'actname' => lang('proxy'),
        'save'    => $row->{'full'},
      }
    );
  };
  $config{'action_func'}{'proxy'} ||= sub {
    my ($row) = @_;
    return
      unless (
      $config{'allow_proxy'} and ( $row->{'prot'} eq 'ftp' or ( $row->{'prot'} eq 'file' ) )    #$config{'system'} eq 'win' and
      and $row->{'size'}
      and $config{'client_ip'} =~ /$config{'proxy_client_mask'}/i
      and $row->{'ip'} =~ /$config{'proxy_server_mask'}/i
      and ( $row->{'name'} or $row->{'ext'} )
      );
    print $config{'redirector'}->( {
        #'goenc' => $config{'root_url'}. '?view=http-dl-ftp&amp;url='. encode_url(join_url($row)). $work{'uparam'},
        'goparam' => { 'view' => 'proxy', 'url' => join_url($row) },
        'actname' => lang('proxy'),
        'save'    => $row->{'full'},
      }
    );
  };
  $config{'action_func'}{'alt'} ||= sub {
    my ($row) = @_;
    #printlog(Dumper $row, $param);
    #print('R1'),
    return if $row->{'no_alt'};
    return unless $row->{'cid'} or $row->{'tiger'} or ( $row->{'size'} and ( $row->{'name'} or $row->{'ext'} ) );
    #print('R2'),
    return
      if $row->{'size'}
        and $row->{'size'} == $param->{'size'}
        and $row->{'name'} eq $param->{'name'}
        and $row->{'ext'}  eq $param->{'ext'};
    print ' ',
      mylink(
      lang('alt'), {
        $row->{'cid'}
        ? ( 'glueg1' => 'or', 'tiger1' => $row->{'cid'} )
        : ( map { $_ => $row->{$_} } grep { $row->{$_} } qw(size name ext) ),
        ( $row->{'tiger'} ? ( 'glueg1' => 'or', 'tiger1' => $row->{'tiger'} ) : () ),
      }
      ),
      ' ';
  };
  $config{'action_func'}{'filelist'} ||= sub {
    my ($row) = @_;
    return unless $row->{'link'};
    print ' ', mylink( lang('filelist'), { split_url( $row->{'link'} ), host => full_host( split_url( $row->{'link'} ) ), } ),
      ' ';
  };
  #
  $config{'redirector'} ||= sub {
    #printlog('dev', $_[0]->{'go'});
    #printlog('devR', $work{'codepage'}, $_[0]->{'cp'}, $config{'cp_db'}, Dumper $_[0]->{'go'});
    ' ' . mylink(
      #lang     ( $_[0]->{'actname'}) || $_[0]->{'go'} ,
      $_[0]->{'actname'} || $_[0]->{'go'},
      $_[0]->{'goparam'}, {
        ( $config{'w3_org_valid'} ? () : 'target' => '_blank' ),
        ( $config{'client_bot'} ? () : ( 'onclick' => 'r(\'' . encode_url( $_[0]->{'save'} or $_[0]->{'go'} ) . '\');' ) ),
        (
          $_[0]->{'goparam'} ? () : 'href' => (
            $_[0]->{'goenc'}
              or encode_url_link(
              #$_[0]->{'go'}
              #$_[0]->{'cp'} ?
              #scalar cp_trans( $work{'codepage'}, $_[0]->{'cp'}, $_[0]->{'go'} )
              #!$_[0]->{'cp'} ||$_[0]->{'cp'} eq 'utf-8'? $_[0]->{'go'} : eval {
              #Encode::encode $_[0]->{'cp'}, $_[0]->{'go'}#}
              #Encode::decode $_[0]->{'cp'}, $_[0]->{'go'}#}
              psmisc::encode_safe( $_[0]->{'cp'}, $_[0]->{'go'} )
                #$_[0]->{'go'}
                #: $_[0]->{'go'}
              )
          )
        ),
        %{ $_[0]->{'goparams'} || {} },
      },
      $_[0]->{'goparamsl'},
    );
  };
  $config{'mylink_rewrite'} ||= sub {    #print Dumper @_;
    $_[3]->{'base'} .= '/' unless $_[3]->{'base'} =~ m{/$};
    for my $page ( @{ $config{'rewrite_pages'} } ) {
      $_[3]->{'base'} .= $page . '/', delete ${ $_[1] }->{'show'} if ${ $_[1] }->{'show'} eq $page;
      #print "${$_[1]};";
    }
    #
    #print "b1[$_[3]->{'base'}; p=${ $_[1] }->{'path'}]";
    if (  length ${ $_[1] }->{'path'}
      and ${ $_[1] }->{'path'} =~ m{.+/.+}
      and ${ $_[1] }->{'path'} !~ m{/\d+/?$}
      and ${ $_[1] }->{'path'} !~ /[:=]/ )
    {
      #${ $_[1] }->{'path'} =~ s{^/}{} unless $_[3]->{'base'} =~ m{/$};
      ${ $_[1] }->{'path'} =~ s{^/}{};
      #print "bp[$_[3]->{'base'}.${ $_[1] }->{'path'}]";
      $_[3]->{'base'} .= ${ $_[1] }->{'path'};
      delete ${ $_[1] }->{'path'};
    } elsif ( $config{'allow_rewrite_q'}
      and ${ $_[1] }->{'q'}
      and ${ $_[1] }->{'q'} !~ m{[/?]}
      and ${ $_[1] }->{'q'} !~ m{^\s*\d+\s*$}
      and ${ $_[1] }->{'q'} !~ m{^\.\w+$} )
    {
      if (  $config{'allow_rewrite_host_force'}
        and ${ $_[1] }->{'q'} =~ m{^[a-z0-9-\s]+$}i
        and length( $config{'allow_rewrite_host_force'} . ${ $_[1] }->{'q'} ) < 64 )
      {
        s/^\s+//, s/\s+$//, s/\s+/./g, for ${ $_[1] }->{'q'};
        my $base = $_[3]->{'base'};
        if ( $base =~ m{://} ) { $base =~ s{^([^:]+://)[^/]+(.*)$}{$1${ $_[1] }->{'q'}.$config{'allow_rewrite_host_force'}$2}; }
        else                   { $base = 'http://' . ${ $_[1] }->{'q'} . '.' . $config{'allow_rewrite_host_force'} . $base; }
        my $host = %{ split_url($base) }->{'host'};
        #print "H[$host]";
        #$config{'allow_rewrite_host'}
        #printlog 'devv', $base, $config{'allow_rewrite_host'}, $config{'allow_rewrite_host_force'};
        if ( $host !~ /$config{'allow_rewrite_host_skip'}/i ) { $_[3]->{'base'} = $base }
        else                                                  { $_[3]->{'base'} .= ${ $_[1] }->{'q'}; }
      } else {
        #not all
        $_[3]->{'base'} .= ${ $_[1] }->{'q'};
      }
      delete ${ $_[1] }->{'q'};
    } elsif ( ${ $_[1] }->{'size'} and ${ $_[1] }->{'size'} >= 10 ) {
      $_[3]->{'base'} .= ${ $_[1] }->{'size'}, delete ${ $_[1] }->{'size'};
    } elsif ( length ${ $_[1] }->{'ext'} and ${ $_[1] }->{'ext'} =~ /^\w+$/ ) {
      #not all
      if ( length ${ $_[1] }->{'name'} and ${ $_[1] }->{'name'} =~ /^[\w\.\-\s()\[\]]+$/ ) {
        $_[3]->{'base'} .= ${ $_[1] }->{'name'}, delete ${ $_[1] }->{'name'};
      }
      $_[3]->{'base'} .= '.' . ${ $_[1] }->{'ext'}, delete ${ $_[1] }->{'ext'};
    }
    $_[3]->{'base'} .= ( $_[3]->{'base'} =~ m{/$} ? '' : '/' ) . ${ $_[1] }->{'page'}, delete ${ $_[1] }->{'page'}
      if ${ $_[1] }->{'page'} > 0 and ${ $_[1] }->{'page'} <= 9;
    $_[3]->{'base'} =~ s{/$}{} if !grep { $_[3]->{'base'} eq $_ } $config{'root_url'}, $config{'root_dir'};
    if ( $config{'rewrite_dummy_force'} ) {
      if    ( $_[3]->{'base'} =~ m{/$} )              { $_[3]->{'base'} .= 'index.' . $config{'rewrite_dummy_force'}; }
      elsif ( $_[3]->{'base'} =~ m{^\w+://[^/]+/.+} ) { $_[3]->{'base'} .= '.' . $config{'rewrite_dummy_force'}; }
      elsif ( $_[3]->{'base'} =~ m{^\w+://[^/]+$} )   { $_[3]->{'base'} .= '/index.' . $config{'rewrite_dummy_force'}; }
    }
    #printlog 'wweb', 'REW', Dumper \@_;
    #@_;
    }
    if $config{'allow_rewrite'};
  #   print 'inita',Dumper $config{'action'};
}

sub rewrite_param {
  my ($param) = @_;
#print "Content-type: text/html\n\n",'<?xml version="1.0"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html>2'    if defined( $ENV{'SERVER_PORT'} and $param->{debug});    # for web dev debug
#TODO
#/known/		-> ?page=known
#/known/zzz	 	-> ?page=known&q=zzz
#/known/zzz?yyy	-> ?page=known&q=zzz&yyy
#/known/?yyy		-> ?page=known&yyy
#/unc 			-> ?page=search&q=unc
#/unc/?xxx 		-> ?page=search&q=unc&xxx
#print "pagep=", Dumper $param, $config{'rewrite'};
#
#
  my $host;
  if ( $config{'allow_rewrite_host'} and $ENV{'SERVER_NAME'} !~ /^\d+\.\d+\.\d+\.\d+$/o ) {
    $host = $ENV{'SERVER_NAME'};
    $host =~ s/\.?$config{'allow_rewrite_host'}$//;
    $host =~ tr/./ /;
  }
  for my $path ( $host, $config{'rewrite'} ) {    #, $ENV{'PATH_INFO'}
    next unless length $path;
    #printlog 'webl', "path[$path]" if $param->{debug};
    $path =~ s{^/+}{};
    #next if $path =~ m{^search/?$};
    for ( @{ $config{'rewrite_dummy'} || [] } ) {
      $config{'allow_rewrite'} = $config{'rewrite_dummy_force'} = $_ if $path =~ s/(?:index)?\.$_$//i;
    }
    if ( $path =~ s{^/?\b(@{[ join '|', @{$config{'rewrite_pages'}||[]} ]})\b/?}{} ) {
      #print "pg[$1] sh[$param->{'show'}]";
      $param->{'show'} ||= $1;
    }
    if ( $path =~ /=/ ) {
      psmisc::hash_merge $param , { get_params($path) };
      #}elsif(grep {$path =~ m{^/?($_)/?$}} @{$config{'rewrite_pages'}}) {
      #$path =~ s{/}{}g;
      #$param->{'show'} ||= $path;
      #print "\n\nSH[$param->{'show'}]";
    } else {
      if ( $path =~ s{(?:^|/)(\d)/?$}{} ) { $param->{'page'} ||= $1; }
      #print('p1', $path);
      if ( $path =~ m{^\w+://\w+[^&?]*} ) { psmisc::hash_merge $param , { 'q' => undef, split_url($path) }; }
      elsif ( $path =~ m{/} )    { $param->{'path'} ||= '/' . $path; }
      elsif ( $path =~ /^\d+$/ ) { $param->{'size'} ||= $path; }
      #elsif ( $path =~ m{^([^/|"]+[^\s/|"])\.([^/\."|]+)$} ) { $param->{'name'} ||= $1; $param->{'ext'} ||= $2; }
      elsif ( my %tparam = $static{'db'}->q_file( $config{'sql_tfile'}, $path ) ) {
        $param->{$_} ||= $tparam{$_}
          for keys %tparam;
      } elsif ( $path =~ m{^\.([^/]+)$} ) {
        $param->{'ext'} ||= $1;
      } elsif ($path) {
        $param->{'q'} ||= $path if length $path;
      }
    }
  }
  #printlog 'R',Dumper $param  if $param->{debug};
  return $param;
}

sub ipre_calc_every {
  my ($param) = @_;
  #for search
  #$config{'log_all'} = ( ( $param->{'debug'} and $config{'allow_debug'} ) ? '#' : '-' );
  #printlog("ipre_calc_every", Dumper $param,
  #\%config
  #\%work,
  #);
  $config{'log_default'} = ( ( $param->{'debug'} and $config{'allow_debug'} ) ? '#' : '-' );
  #$config{'log_dmp'}= '#';
  #$config{'log_screen'} = 1 if $config{'log_all'} eq '#';
  #$config{'log_default'} = '-weblog.log';
  #psmisc::printlog
  #warn('dev', "locALE=", "$work{'lang'}_" . uc("$work{'lang'}.$work{'codepage'}"));
  #setlocale( LC_ALL, "$work{'lang'}_" . uc("$work{'lang'}.$work{'codepage'}") );
  #setlocale( LC_ALL, "$work{'lang'}_" . uc("$work{'lang'}.$work{'codepage'}") );
  #LC_COLLATE
  #setlocale( LC_CTYPE, "$work{'lang'}_" . uc("$work{'lang'}.$work{'codepage'}") );
  #);
  #cp_trans_hash( $work{'codepage'}, $config{'cp_int'}, $param );
  my (%user_param_all);
  @user_param_all{ ( @{ $config{'user_param'} }, @{ $config{'user_param_hidden'} } ) } =
    @{$param}{ ( @{ $config{'user_param'} }, @{ $config{'user_param_hidden'} } ) }
    if $config{'user_param'} and $config{'user_param_hidden'};
  $work{'uparam'}     = psweb::get_param_str( \%user_param_all );
  $work{'uparam'}     = '&amp;' . $work{'uparam'} if $work{'uparam'};
  $work{'sparam'}     = $work{'uparam'};
  $work{'sparam'}     = $config{'root_url'} . '?' . $work{'sparam'};
  $work{'counter'}    = getcount() if $config{'stupid_hit_counter'};
  $work{'show_tiger'} = 1 if 0 < grep { $param->{ 'tiger' . ( $_ or '' ) } } ( 0 .. 10 );
  $work{'show_tiger'} = undef unless $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'tiger'};
  $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'tiger'}{'nav_field'} = 1
    if $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'tiger'} and $work{'show_tiger'};
  my %t;
  @t{ grep( $_ =~ /\w/, split( /\|\|/, $param->{'queries'} ) ) } = ( 0 .. $config{'top_query'} );
  @{ $work{'queries'} } = sort { $t{$a} <=> $t{$b} } keys %t;
  %t = ();
  @t{ grep( $_ =~ /\w/, split( /\|\|/, $param->{'dls'} ) ) } = ( 0 .. $config{'top_query'} );
  @{ $work{'dls'} } = sort { $t{$a} <=> $t{$b} } keys %t;
  $work{'dls_string'} = join '', map { '||' . encode_url($_) } grep { $_ } ( @{ $work{'dls'} } )[ 0 .. $config{'top_query'} ];
  #printlog "testquery", $config{'sql'}{'table_param'}{ $config{ 'sql_t' . 'query' . 'stat' } }{'filter'}, $param->{'q'};
  #dmp (\%user_param_all);
  for my $p ( map { $param->{$_} } qw(q q1 name path) ) {
    next if length $p < 3;
    if (
      psmisc::code_run(
        $config{'sql'}{'table_param'}{ $config{ 'sql_t' . 'query' . 'stat' } }{'filter'},
        undef, {
          'query' => $p
            #$param->{'q'}
        }
      )
      )
    {
      #printlog "testquery",'MATCH', $p;
      $work{'query_filtered'} = 1;
      last;
    }
  }
  #dmp $work{'query_filtered'};
  if ( $config{'use_sphinx'} and $param->{'q'} ) { $config{'no_plus_minus'} = 1; }
  #$static{'db'}->user_params($param);
  #$static{'db'}->next_user_prepare();
  psweb::next_user($param);
  $static{'db'}->next_user($param);
  $static{'db_sphinx'}->next_user($param) if $static{'db_sphinx'};
}

sub init {
  %work = %stat = ();
  ++$static{'runs'};
  $work{'page_start'} = timer();
  $param = psmisc::get_params_utf8();
  print("Content-type: text/html\n\n"), if $param->{'debug'};
  #utf8::decode($param->{$_})
  #print('BD:', Dumper $param);
  #utf8::encode($param->{$_}),
  #print('cp:',
  #psmisc::cp_detect_trans( $param->{$_} ) for keys %$param;
  #print('AD:', Dumper $param);
  #print "index::init();" ,Dumper $param;
  psmisc::config_init($param);
  psweb::config_init($param);
  psmisc::config_reload(
    $ENV{'MOD_PERL'} || $ENV{'FCGI_ROLE'}    #, undef,
           #sub{print "index::RELOADbySUB;";psweb::config_init($param);psmisc::config_init($param);}
  );
  psmisc::pre_calc_once($param);
  ipre_calc_once($param);
  rewrite_param($param);
  psmisc::pre_calc_every($param);
  #psweb::init_every() ;
  ipre_calc_every($param);
}

sub pinger {
  my ($param) = @_;
  my $ret = 'yellow';
  return 'yellow' unless $param->{'host'};
  return '' if $param->{'prot'} and !$config{'scanner'}{ $param->{'prot'} }{'pingable'};
  #my $table = $config{'sql_thost'};
  #local $config{'allow_auto_repair'}   = 0;
  #local $config{'sql_reconnect_tries'} = 1;
  #local $config{'sql_reconnect_sleep'} = 0;
  #local $config{'sql_error_tries'}     = 0;
  #local $config{'sql_error_sleep'}     = 0;
  #local $config{'sql'}{'database'}     = $config{'sql_base_up'};    #!

=c
  sub sql_update_double {
    local $_ = $static{'db_up'}->update(@_);
    if (  $config{'pinger_double_update'}
      and $config{'sql_base_web'}
      and ( $static{'db'}{'database'} ne $config{'sql_base_web'} ) )
    {
#local $static{'db'}{'database'} = $config{'sql_base_web'};
      #printlog('upd', Dumper(\@_));
      $static{'db'}->update(@_);
    }
    return $_;
  }
=cut

  #printlog( 'dev', 'ping start', %$param);
  #my $tim = timer();
  if ( $param->{'hostscan'} < time() - $config{'ping_interval'} and $param->{'live'} < time() - $config{'ping_interval'} ) {
    my ( $port, $host );
    $param = { %$param, split_url( $param->{'host'} ) };
    if ( $config{'scanner'}{ $param->{'prot'} }{'pingable'} eq 'ip' ) {
      if ( $param->{'dcuser'} ) {
        $port = $param->{'hostport'} || $param->{'port'};
        $host = $param->{'ip'};
      }
    } else {
      $port =
           $param->{'port'}
        || $config{'scanner'}{ $param->{'prot'} }{'port'}
        || ( $param->{'prot'} ? getservbyname( $param->{'prot'}, 'tcp' ) : 0 );
      $host = $param->{'ip'} || $param->{'host'};
    }
    next unless $host;
    my $prot = ( $port ? 'tcp' : 'icmp' );
    printlog( 'dbg', 'port', $port, 'host', $host, $prot );
    next if $prot eq 'icmp' and ( $> and $^O ne 'VMS' and $^O ne 'cygwin' );
    my $p;
    eval { $p = Net::Ping->new( $prot, $config{'ping_timeout'} ); };
    printlog( 'dbg', 'p[must be non null]=', $p, 'host=', $host, 'port=', $port, $prot );
    return '' unless $p and $host;
    $p->{'port_num'} = $port if $port;
    $_->retry_off() for @{ $static{'dbs_up'} };

    if ( $p->ping($host) ) {
      $ret = 'lightgreen';
      psmisc::flush();
      #sql_update_double
      $_->update(
        $config{'sql_thost'},
        undef, {
          $static{'db'}->filter_row( $config{'sql_thost'}, 'primary', $param ),
          'time' => int( time() ),
          'scan' => int( time() ),
          'host' => full_host($param)
        }
      ) for @{ $static{'dbs_up'} };
      printlog( 'dbg', 'ping ok' );
    } else {
      $ret = 'red';
      psmisc::flush();
      my %time = ( 'time' => ( int( time() ) - $config{'online_minutes'} * 60 ) )
        if ( $param->{'live'} + $config{'online_minutes'} * 60 ) > time();
      #sql_update_double
      $_->update(
        $config{'sql_thost'},
        undef, {
          $static{'db'}->filter_row( $config{'sql_thost'}, 'primary', $param ), %time,
          'scan' => int( time() ),
          'host' => full_host($param)
        }
      ) for @{ $static{'dbs_up'} };
      printlog( 'dbg', 'ping none', full_host($param) );
    }
  } elsif ( $param->{'live'} < time() - $config{'ping_interval'} ) {
    $ret = "red";
  } else {
    $ret = "green";
  }
  #printlog( 'dmp', 'ping done per', human{'time_period'}->( $tim->() ));
  $_->retry_on() for @{ $static{'dbs_up'} };
  return $ret;
}

=dummy
  $config{'out'}{'html'}{'form-'} = sub {
    my ($param, $table, $fparam, $paramnum, $valuenum) = @_;
  };
=cut

sub redirect_update {
  my ( $param, $table ) = @_;
  #printlog( 'dev', 'redirect_update' );
  return if $config{'no_update_dl'} or $config{'client_bot'};
  psmisc::flush();
  local $config{'sql'}{'database'} = $config{'sql_base_wup'};
  $param->{'save'} ||= $param->{'go'};
  $param->{'save'} =~ s|^(file://)///|$1| if $config{'client_firefox'};
  %_ = %{ split_url( $param->{'save'} ) };
  return unless $_{'host'};
  $_{'host'} = full_host( \%_ );
#$static{'db'}->update( $config{'sql_tfile'}, undef, \%_, 1, "`dl` = `dl`+'1'" ) if $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'dl'};
  if ( $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'dl'} ) {
    $_->update( $config{'sql_tfile'}, undef, \%_, 1, "`dl` = `dl`+'1'" ) for @{ $static{'dbs_up'} };
  }
  if ( $config{'sql'}{'table'}{ $config{'sql_tresource'} }{'dl'} ) {
    $_->update( $config{'sql_tresource'}, undef, { %_, %{ $config{'clear_file'} } }, 1, "`dl` = `dl`+'1'" )
      for @{ $static{'dbs_up'} };
  }
#$static{'db'}->update( $config{'sql_tresource'}, undef, { %_, %{ $config{'clear_file'} } }, 1, "`dl` = `dl`+'1'" )    if $config{'sql'}{'table'}{ $config{'sql_tresource'} }{'dl'};
  if ( $config{'sql'}{'table'}{ $config{'sql_thost'} }{'dl'} ) {
    $_->update( $config{'sql_thost'}, undef, \%_, 1, "`dl` = `dl`+'1'" ) for @{ $static{'dbs_up'} };
  }
#$static{'db'}->update( $config{'sql_thost'}, undef, \%_, 1, "`dl` = `dl`+'1'" )    if $config{'sql'}{'table'}{ $config{'sql_thost'} }{'dl'};
  if ( $config{'allow_topfiles'} and ( $_{'name'} or $_{'ext'} ) ) {
    $_->update(
      $config{'sql_tfilestat'},
      undef, { 'file' => $param->{'save'}, 'last' => int( time() ), 'lastip' => $config{'client_ip'} },
      undef, "`lastip` = '$config{'client_ip'}', `dl` = `dl`+'1'"
    ) for @{ $static{'dbs_up_all'} };
  }
#$static{'db'}->update(    $config{'sql_tfilestat'},    undef, { 'file' => $param->{'save'}, 'last' => int( time() ), 'lastip' => $config{'client_ip'} },    undef, "`lastip` = '$config{'client_ip'}', `dl` = `dl`+'1'"  ) if $config{'allow_topfiles'} and ( $_{'name'} or $_{'ext'} );
}
#
#$processor{'out'}{'sql'} ||= sub { return $static{'db'}->do(@_); };
#
#sub devlog { if (open FD, ">>", 'C:/pro/search/web/index.log' ) {print FD join (' ', @_), "\n";close FD}}
BEGIN {
  psmisc::conf(
    sub {
      $config{'out'}{''}{'result_string_pre'} ||= sub {
        my ( $param, $table, $row ) = @_;
        #psweb::cp_trans_row($row);
        $row->{'full'} = join_url($row);
        $row->{'full'} =~ s|^(file://)|$1///| if $config{'client_firefox'};
        $row->{'can_show'} = 1
          if !$config{'no_player'}
            and $config{'exts'}{ lc( $row->{'ext'} ) }{'can_show'}
            and $row->{'size'}
            and $row->{'size'} < min(
              map { psmisc::human( 'number_k', $config{$_} ) } grep { $config{$_} } (
                'play_max', 'play_max_' . lc( $row->{'prot'} ), 'play_max_' . $config{'exts'}{ lc( $row->{'ext'} ) }{'type'}
              )
            ) and $config{'scanner'}{ lc( $row->{'prot'} ) }{'view'};
        #and !( $config{'exts'}{ lc( $row->{'ext'} ) }{'player'} eq 'wmp'
        #  and $row->{'prot'} eq 'ftp'
        #  and ( $config{'client_opera'} or $config{'client_firefox'} )
        #);
        $row->{'show'} = 1
          if $row->{'can_show'}
            and ( $work{'img'} =~ /(al*)|(on)/i or psmisc::human( 'number_k', $work{'img'} ) >= $row->{'size'} )
            and $config{'exts'}{ lc( $row->{'ext'} ) }{'type'} eq 'image';
        $row->{$1} ||= $2 while ( $row->{'desc'} =~ s/^\s*(\w+\S*)\=(\S+)\s*//i );               #remove later
        $row->{$1} ||= decode_url($2) while ( $row->{'meta'} =~ s/^\s*(\w+\S*)\=(\S+)\s*//i );
        #printlog('dev', 'old cp', $row->{'cp'});
        $row->{'cp'} ||= hconfig( 'cp_res', $row->{'host'}, $row->{'prot'} );
        #printlog('dev', 'new cp', $row->{'cp'});
        #print "[[[[CP!$row->{'cp'}]";
      };
      $config{'out'}{''}{'show'} ||= sub { };
      $config{'out'}{'html'}{'form-online'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        print $config{'sel_sep_head'};
        my $link = 1 if $config{'result'};
        print '<a href="#" onclick="gid(\'online' . $paramnum . '\').checked=\'',
          ( $param->{ 'online' . $valuenum } ? '' : 'checked' ), '\'; dosubmit(); return false;">',
          if $link;
        print lang('online');
        print '</a>' if $link;
        print ' <input type="checkbox" ', nameid( 'online' . $paramnum ), ' ',
          ( ( $param->{ 'online' . $valuenum } eq 'on' ) ? 'checked="checked"' : '' ), '/>';
      };
      $config{'out'}{'html'}{'form-help-what-win'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        #return unless %{$config{'preset'}};
        for my $preset (qw(what ext)) {
          next unless %{ $config{'preset'}{$preset} };
          for
            my $type ( sort { $config{'preset'}{$preset}{$a}{'order'} <=> $config{'preset'}{$preset}{$b}{'order'} || $a cmp $b }
            grep { !$config{'preset'}{$preset}{$_}{'skip_what'} } keys %{ $config{'preset'}{$preset} } )
          {
            #print scalar keys %{ $config{'preset'}{$preset}{$type}{'set'} };
            #print "$preset, $type, $config{'preset'}{$preset}{$type}{'order'}: $config{'preset'}{$preset}{$type}{'type'}";
            print '<a href="#" onclick="',
              #map( { ( 'repl(\'', $_, $paramnum, '\',\'value\',\':', $type, '\');' ) }
              (
              $config{'use_type'} && defined $config{'preset'}{$preset}{$type}{'type'}
              ? (qq{repl('type$paramnum', 'value', '$config{'preset'}{$preset}{$type}{'type'}');})
              : (
                map {
                  (
                    'repl(\'',
                    $_,
                    $paramnum,
                    '\',\'value\',\'', (
                      scalar keys %{ $config{'preset'}{$preset}{$type}{'set'} } > 1
                      ? ( $config{'preset'}{$preset}{$type}{'set'}{$_} )
                        #: ( ':', $type, )
                      : ( ':', $type )
                    ),
                    '\');'
                    )
                  } keys %{ $config{'preset'}{$preset}{$type}{'set'} }
              ),
              ),
              ' menu_hide();show_adv(1);return false;">', lang($type), '</a>';    #<br/>
          }
        }
      };
      $config{'out'}{'html'}{'form-help-where-win'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        print '<a href="#" onclick="repl(\'host', $paramnum, '\',\'value\',\':', $_, '\'); if (gid(\'host', $paramnum,
          '\').value) {show_adv(1);};menu_hide();return false;">', lang($_), '</a>'
          for ( sort { $config{'host'}{$a}{'order'} <=> $config{'host'}{$b}{'order'} } keys %{ $config{'host'} } );
      };
      $config{'out'}{'html'}{'form-help-when-win'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        print '<a href="#" onclick="repl(\'search_days', $paramnum, '\',\'value\',\'', $_, '\'); if (gid(\'search_days',
          $paramnum, '\').value) {show_adv(1);};menu_hide();return false;">', lang( $config{'when'}{$_} ), '</a>'    #<br/>
          for ( sort { $a <=> $b } keys %{ $config{'when'} } );                                                      #'always',
        #print  '</select> ';
      };
      $config{'out'}{'html'}{'form-help-what-select'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        #return unless %{ $config{'ext'} };
        #        $config{'use_type'} && defined $config{'preset'}{$preset}{$type}{'type'}
        #? (qq{repl('type$paramnum', 'value', '$config{'preset'}{$preset}{$type}{'type'}');})
        #my $preset = 'what';
        print '<select ', nameid( 'what_help' . $paramnum ), ' dir="ltr" onchange="repl(\'',
          ( $config{'use_type'} ? 'type' : 'ext' ), $paramnum, '\',\'value\',this.value); if (this.value) {show_adv(1);};">',
          '<option value="">', lang('what'), '</option>';
        for my $preset (qw(what ext)) {
          #for my $type ( sort { $config{'ext'}{$a}{'order'} <=> $config{'ext'}{$b}{'order'} } keys %{ $config{'ext'} } ) {
          next unless %{ $config{'preset'}{$preset} };
          for
            my $type ( sort { $config{'preset'}{$preset}{$a}{'order'} <=> $config{'preset'}{$preset}{$b}{'order'} || $a cmp $b }
            grep { !$config{'preset'}{$preset}{$_}{'skip_what'} } keys %{ $config{'preset'}{$preset} } )
          {
            #next if $config{'ext'}{$type}{'skip_what'};
            print '<option value="', ( $config{'use_type'} ? ( $config{'preset'}{$preset}{$type}{'type'} ) : ':' . $type ),,
              '" ', ( (
                ( $config{'use_type'} and $param->{ 'type' . $valuenum } eq $config{'preset'}{$preset}{$type}{'type'} )
                  or $param->{ 'ext' . $valuenum } eq ':' . $type
              ) ? 'selected="selected"' : ''
              ),
              '>', lang($type), '</option>';
          }
        }
        print '</select> ';
      };
      $config{'out'}{'html'}{'form-help-what-div'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        print '<a class="link-block" href="#" onclick="menu_toggle(this, gid(\'form-help-what-win\'), -10, 4);return false;">',
          lang('what'), '</a>';
        part( 'form-help-what-win', $param, $table, undef, { 'cont_param' => ' style="display:none;" ' }, $paramnum,
          $valuenum );
      };
      $config{'out'}{'html'}{'form-help-where-select'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        return unless %{ $config{'host'} };
        print '<select ', nameid( 'where_help' . $paramnum ), ' dir="ltr" onchange="repl(\'host', $paramnum,
          '\',\'value\',this.value); if (this.value) {show_adv(1);};">', '<option value="">', lang('where'), '</option>';
        print '<option value=":', $_, '" ', ( $param->{ 'host' . $valuenum } eq ':' . $_ ? 'selected="selected"' : '' ), '>',
          lang($_), '</option>'
          for ( sort { $config{'host'}{$a}{'order'} <=> $config{'host'}{$b}{'order'} } keys %{ $config{'host'} } );
        print '</select> ';
      };
      $config{'out'}{'html'}{'form-help-where-div'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        return unless %{ $config{'host'} };
        print '<a class="link-block" href="#" onclick="menu_toggle(this, gid(\'form-help-where-win\'), -10, 4);return false;">',
          lang('where'), '</a>';
        part( 'form-help-where-win', $param, $table, undef, { 'cont_param' => ' style="display:none;" ' },
          $paramnum, $valuenum );
      };
      $config{'out'}{'html'}{'form-help-when-select'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        return unless %{ $config{'when'} };
        print '<select ', nameid( 'when_help' . $paramnum ),
          ' dir="ltr" onchange="repl(\'search_days\',\'value\',this.value); if (this.value) {show_adv(1);};">',
          '<option value="">', lang('when'), '</option>';
        print '<option value="', $_, '" ', ( $param->{ 'search_days' . $valuenum } eq $_ ? 'selected="selected"' : '' ), '>',
          lang( $config{'when'}{$_} ), '</option>'
          for ( sort { $a <=> $b } keys %{ $config{'when'} } );
        print '</select> ';
      };
      $config{'out'}{'html'}{'form-help-when-div'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        return unless %{ $config{'when'} };
        print '<a class="link-block" href="#" onclick="menu_toggle(this, gid(\'form-help-when-win\'), -10, 4);return false;">',
          lang('when'), '</a>';
        part( 'form-help-when-win', $param, $table, undef, { 'cont_param' => ' style="display:none;" ' }, $paramnum,
          $valuenum );
      };
      $config{'out'}{'html'}{'form-help'} ||= sub {
        my ( $param, $table, $fparam, $cparam, $paramnum, $valuenum ) = @_;
        part( 'form-help-what-' . ( $config{'help_select_div'} ? 'div' : 'select' ),
          $param, $table, undef, undef, $paramnum, $valuenum )
          if ( !$config{'no_what_help'} and $config{'ext'} and $config{'sql'}{'table'}{$table}{'ext'} );
        part( 'form-help-where-' . ( $config{'help_select_div'} ? 'div' : 'select' ),
          $param, $table, undef, undef, $paramnum, $valuenum )
          if ( !$config{'no_where_help'} and $config{'host'} and $config{'sql'}{'table'}{$table}{'host'} );
        part( 'form-help-when-' . ( $config{'help_select_div'} ? 'div' : 'select' ),
          $param, $table, undef, undef, $paramnum, $valuenum )
          if ( !$config{'no_when_help'} and $config{'sql'}{'table'}{$table}{'time'} );
      };
      $config{'out'}{'html'}{'result_string_img'} ||= sub {
        my ( $param, $table, $row ) = @_;
        my $file = $row->{'img'};
        {
          {
            next unless grep { $row->{$_} } qw(prot host dcuser path name ext);
            if ( !$row->{'path'} and !$row->{'name'} and !$row->{'ext'} ) {
              $file ||= is_img('dcuser') if $row->{'dcuser'};
              $file ||= is_img( lc $row->{'prot'} );
              $file ||= is_img('res');
              last;
            }
            $file ||= is_img('dir'), last if !$row->{'size'};
            $file ||= is_img( lc $row->{'ext'} );
            $file ||= is_img( $config{'exts'}{ lc $row->{'ext'} }{'type'} );
            $file ||= is_img('unk');
          }
        };
        print '<img class="result_string_img" src="',
          #$config{'root_dir'},
          $file, '"/>' if $file;
      };
      $config{'out'}{'html'}{'result_head'} = sub {
        my ( $param, $table ) = @_;
        psmisc::printall( \$config{'html_result_header_top'}, $param ) unless $param->{'no_result_header'};
        $work{'n'} = $static{'db'}->{'limit_offset'};
        print '<table class="result-table" ';
        psmisc::printall( \$config{'html_result-table_param'}, $param );
        print '>';
        return if $param->{'no_result_header'};
        if ( $config{'one_string'} and keys %{ $work{'one'} } ) {
          local $work{'n'} = -1;
          my (%string) = (%$param);
          delete $string{$_} for grep ( ( $work{'one'}{$_} != 1 ), keys %string );
          $string{'full'} = join_url( \%string );
          local $work{'one'}                = ();
          local $config{'allow_vote'}       = 0;
          local $config{'no_dir_word'}      = 1;
          local $config{'allow_pinger'}     = 0;
          local $config{'no_rel_path_link'} = 0;
          part( 'result_string_pre',  $param, $table, \%string, { 'no_cont' => 1 } );
          part( 'result_string',      $param, $table, \%string, { 'no_cont' => 1 }, { 'no_stat' => 1 } );
          part( 'result_string_post', $param, $table, \%string, { 'no_cont' => 1 } );
        }
        print '<tr class="result-head"><td>N</td>';
        if ( $param->{'distinct'} ) { print '<td>', $param->{'distinct'}, '</td>'; }
        else {
          my %ord_param_hash = get_param_hash( $param, ( 'order', 'order_mode', 'page' ) ) unless $config{'destroy_link_sort'};
          print '<td>';
          #sorter here
          psweb::sorter( $param, { 'order' => $_ }, \%ord_param_hash )
            for
            grep ( ( $config{'sql'}{'table'}{$table}{$_}{'row'} and !$work{'one'}{$_} ), qw(prot host dcuser path name ext) )
            ;    #primary?
          print '</td><td>';
          print lang('file'), ' ' if $config{'no_split_link'};
          psweb::sorter( $param, { 'order' => 'voteu', 'lang' => 'rate up', 'no_down' => 1, 'no_sep' => 1 }, \%ord_param_hash ),
            psweb::sorter( $param, { 'order' => 'voted', 'lang' => 'rate down', 'no_down' => 1, 'no_sep' => 1 },
            \%ord_param_hash )
            if $config{'allow_vote'};
          psweb::sorter( $param, { 'order' => 'dl', 'no_down' => 1, 'no_sep' => 1 }, \%ord_param_hash );
          print '</td><td>';
          psweb::sorter( $param, { 'order' => 'size', 'no_sep' => 1 }, \%ord_param_hash );

          unless ( $config{'no_files_dirs'} ) {
            psweb::sorter( $param, { 'order' => $_, 'no_down' => 1 }, \%ord_param_hash )
              for grep $config{'sql'}{'table'}{$table}{$_}{'row'}, ( 'files', 'dirs' );
          }
          print '</td><td>';
          psweb::sorter( $param, { 'order' => 'time', 'lang' => 'changed', 'no_sep' => 1 }, \%ord_param_hash )
            if ( $config{'sql'}{'table'}{$table}{'time'}{'row'} );
          print '</td><td>';
          print '<span id="head_desc">', lang('description'), '</span>' if $config{'sql'}{'table'}{$table}{'desc'}{'row'};
          print '</td><td>';
          psweb::sorter( $param, { 'order' => 'tiger', 'lang' => 'tiger', 'no_sep' => 1 }, \%ord_param_hash ),
            print('</td><td>')
            if $work{'show_tiger'};
          psweb::sorter( $param, { 'order' => 'scan', 'lang' => 'scanned', 'no_sep' => 1, 'no_down' => 1 }, \%ord_param_hash )
            if $config{'sql'}{'table'}{$table}{'scan'}{'row'} and !$config{'no_row_scan'};
          print '</td></tr>';
        }
      };
      $config{'out'}{'html'}{'result_string'} = sub {
        my ( $param, $table, $row, undef, $fparam ) = @_;
        my $fullhost;
        $fparam ||= {};
        #$row->{'desc'} =~ s/\\n/<br\/>/g;
        #print "<tr><td colspan=\"10\">", join( ':', %$row ), "</td></tr>" if $param->{'debug'};
        #print "<tr><td colspan=\"10\">", Dumper($row), "</td></tr>" if $param->{'debug'};
        #print "<tr><td colspan=\"10\">", $row->{weight}, "</td></tr>" if $param->{'debug'};
        ++$work{'n'};
        $row->{'n'}  ||= $work{'n'};
        $row->{'na'} ||= $work{'n'};
        print qq{<tr><td colspan="20" class="fulltext-fail">}, lang('results for'), ' "',
          mylink( $row->{'__fulltext_fail'}, { 'q' => $row->{'__fulltext_fail'} } ), qq{":</tr>}
          if $row->{'__fulltext_fail'};
        print qq{<tr data-n="$row->{'n'}" data-na="$row->{'na'}" align="left" class="result-}, ( $row->{'n'} % 2 ), '">',
          '<td><a name="n', $row->{'n_id'}, $row->{'n'},
          "\" $config{'destroy_link'}href=\"#n$row->{'n_id'}$row->{'n'}\">$row->{'n'}</a>",
          ( $row->{'host'} =~ /^$config{'client_ip'}(\:\d+)?$/ ? '>' : '' ), '</td>', '<td>';
        print mylink( $row->{'full'}, { $param->{'distinct'} => $row->{'full'} }, undef,
          { 'destroy' => $config{'destroy_link'} } ), '</td></tr>'
          and return
          if $param->{'distinct'};
        part( 'result_string_img', $param, $table, $row, { 'no_cont' => 1 } );
        if ( $config{'no_split_link'} ) { psmisc::printall $config{'no_split_link'}, $row if ref $config{'no_split_link'} }
        else {

          unless ( $work{'one'}{'prot'} == 1
            and $work{'one'}{'host'} == 1
            and $work{'one'}{'path'} == 1
            and ( !%{ $config{'sql'}{'table'}{$table}{'dcuser'} || {} } xor $work{'one'}{'dcuser'} == 1 ) )
          {
            unless ( $config{'no_rel_path_link'} ) {
              print mylink(
                out_bold( $row->{'prot'}, $work{'bold_prot'} ),
                { 'prot' => $row->{'prot'} },
                undef, { 'destroy' => $config{'destroy_link'} }
                ),
                if length $row->{'prot'};
              print mylink(
                '://',
                { map { $_ => $row->{$_} } qw(prot host) },
                { 'class'   => 'space' },
                { 'destroy' => $config{'destroy_link'} }
                ),
                if length $row->{'prot'} and length $row->{'host'};
              unless ( $work{'hide_user'} ) {
                print mylink(
                  out_bold( $row->{'user'}, $work{'bold_user'} ),
                  { 'user' => $row->{'user'} },
                  undef, { 'destroy' => $config{'destroy_link'} }
                  ),
                  if length $row->{'user'};
                unless ( $config{'hide_pass'} ) {
                  print mylink(
                    ':',
                    { map { $_ => $row->{$_} } qw(user pass) },
                    { 'class'   => 'space' },
                    { 'destroy' => $config{'destroy_link'} }
                    ),
                    if length $row->{'user'} and length $row->{'pass'};
                  print mylink(
                    out_bold( $row->{'pass'}, $work{'bold_pass'} ),
                    { 'pass' => $row->{'pass'} },
                    undef, { 'destroy' => $config{'destroy_link'} }
                    ),
                    if length $row->{'user'} and length $row->{'pass'};
                }
                print mylink(
                  '@',
                  { map { $_ => $row->{$_} } qw(user pass host) },
                  { 'class'   => 'space' },
                  { 'destroy' => $config{'destroy_link'} }
                  ),
                  if length $row->{'user'};
              }
              print mylink(
                out_bold( $row->{'host'}, '', split( /\s+|\*/, $work{'bold_host'} ) ),
                { 'host' => $row->{'host'} },
                undef, { 'destroy' => $config{'destroy_link'} }
                ),
                if length $row->{'host'};
              print mylink(
                '/',
                { 'path'    => '/', map { $_ => $row->{$_} } qw(prot host) },
                { 'class'   => 'space' },
                { 'destroy' => $config{'destroy_link'} }
                ),
                if length $row->{'host'} and length $row->{'dcuser'};
              print " ... " if !length $row->{'host'} and ( length $row->{'prot'} or length $row->{'path'} );
              print mylink(
                out_bold( $row->{'dcuser'}, '', split( /\s+|\*/, $work{'bold_dcuser'} ) ),
                { 'dcuser' => $row->{'dcuser'} },
                undef, { 'destroy' => $config{'destroy_link'} }
                ),
                if length $row->{'dcuser'};
              #TODO
              print " ... " if !length $row->{'host'} and ( length $row->{'prot'} or length $row->{'path'} );
              print mylink(
                ':',
                { map { $_ => $row->{$_} } qw(host port) },
                { 'class'   => 'space' },
                { 'destroy' => $config{'destroy_link'} }
                ),
                mylink(
                out_bold( $row->{'port'}, $work{'bold_port'} ),
                { 'port' => $row->{'port'} },
                undef, { 'destroy' => $config{'destroy_link'} }
                ),
                if length $row->{'port'};
            } else {
              $fullhost = out_bold( join_url( { %$row, 'path' => undef, 'name' => undef, 'ext' => undef, } ),
                $work{'bold_prot'} . $work{'bold_user'} . $work{'bold_pass'} . $work{'bold_host'} . $work{'bold_port'} );
            }
            print mylink(
              $fullhost . '/', {
                'path' => '/',
                map { $_ => $row->{$_} } qw(prot host),
                ( %{ $config{'sql'}{'table'}{$table}{'dcuser'} or {} } ? ('dcuser') : () )
              },
              { 'class'   => 'space' },
              { 'destroy' => $config{'destroy_link'} }
              ),
              if length $row->{'host'}
                and ($fullhost
                  or ( length $row->{'path'} and $row->{'path'} ne '/' )
                  or length $row->{'name'}
                  or length $row->{'ext'} );
            my $p = '';
            for my $pp ( split( /\/+/, $row->{'path'} ) ) {
              #print("P[$pp]");
              next if $pp !~ /\S/;
              $p .= '/' . $pp unless $pp eq 'EMPTY';
              my $ppp = out_bold( $pp, $work{'search_str'} . $work{'bold_path'} );
              print( mylink( $ppp, { 'path' => $p }, { 'class' => 'spacer' }, { 'destroy' => $config{'destroy_link'} } ), ),
                $ppp = ''
                unless ( $config{'no_rel_path_link'} );
              print mylink(
                $ppp . '/', {
                  'path' => $p,
                  map { $_ => $row->{$_} } qw(prot host),
                  ( %{ $config{'sql'}{'table'}{$table}{'dcuser'} or {} } ? ('dcuser') : () )
                },
                { 'class'   => 'spacer' },
                { 'destroy' => $config{'destroy_link'} }
                ),
                ;
            }
          }
          $fullhost = '';
          if ( !$config{'no_rel_path_link'} or $row->{'size'} ) {
            print mylink(
              out_bold( $row->{'name'}, $work{'search_str'} . $work{'bold_name'} ), {
                  ( $row->{'size'} or !length $row->{'path'} )
                ? ( 'name' => $row->{'name'} )
                : ( 'path' => $row->{'path'} . ( $row->{'path'} eq '/' ? '' : '/' ) . $row->{'name'} )
              },
              undef,
              { 'destroy' => $config{'destroy_link'} }
              ),
              if length $row->{'name'};
            print mylink(
              '.',
              { 'name' => ( length $row->{'name'} ? $row->{'name'} : 'EMPTY' ), 'ext' => $row->{'ext'} },
              { 'class'   => 'space' },
              { 'destroy' => $config{'destroy_link'} }
              ),
              if length $row->{'name'} and length $row->{'ext'};
            print mylink(
              out_bold( $row->{'ext'}, $work{'search_str'} . $work{'bold_ext'} ),
              { 'ext' => $row->{'ext'} },
              undef, { 'destroy' => $config{'destroy_link'} }
              ),
              if length $row->{'ext'};
            print '?', $row->{'param'} if length $row->{'param'};
            print '#', $row->{'pos'}   if length $row->{'pos'};
          } else {
            $fullhost = out_bold(
              join_url( { 'name' => $row->{'name'}, 'ext' => $row->{'ext'} } ),
              $work{'search_str'} . $work{'bold_name'} . $work{'bold_ext'}
            );
          }
          #print "Z1";
          print mylink(
            $fullhost . '/', {
              'path' => ( length $row->{'path'} ? $row->{'path'} : '/' )
                . ( length $row->{'name'} ? ( $row->{'path'} ne '/' ? '/' : '' ) . $row->{'name'} : '' )
                . ( length $row->{'ext'} ? '.' . $row->{'ext'} : '' ),
              map { $_ => $row->{$_} } qw(prot host), ( %{ $config{'sql'}{'table'}{$table}{'dcuser'} or {} } ? ('dcuser') : () )
            },
            { 'class'   => 'spacel' },
            { 'destroy' => $config{'destroy_link'} }
            ),
            if length $row->{'host'}
            and
            (  ( $row->{'path'} eq '/' and !( length $row->{'name'} or length $row->{'ext'} ) and !$config{'no_rel_path_link'} )
            or ( !$config{'no_rel_path_link'} and !length $row->{'path'} )
            or ( ( length $row->{'name'} or length $row->{'ext'} ) and ( !$row->{'size'} or $row->{'files'} ) ) );
        }
        if (  !$config{'no_plus_minus'}
          and length $row->{'host'}
          and ( length $row->{'path'} or length $row->{'name'} or length $row->{'ext'} )
          and $param->{'host'} ne $row->{'host'} )
        {
          #TODO
          my %hparam = %$param;
          $hparam{'host'} = ( length $param->{'host'} ? $param->{'host'} . ' AND ' : '' ) . '!' . $row->{'host'};
          psmisc::printu "   ",
            mylink(
            '-',
            { get_param_hash( \%hparam, ( @{ $config{'skip_from_link'} } ) ) },
            { 'title'   => lang('skip this host') },
            { 'destroy' => $config{'destroy_link'} }
            ),
            ;
          $hparam{'host'} = ( length $param->{'host'} ? $param->{'host'} . ' OR ' : '' ) . $row->{'host'};
          print " ",
            mylink(
            '+',
            { get_param_hash( \%hparam, ( @{ $config{'skip_from_link'} } ) ) },
            { 'title'   => lang('only on this host') },
            { 'destroy' => $config{'destroy_link'} }
            ),
            ;
        }
        print '</td>', '<td class="action-tab" ', $config{'html_action-tab_param'}, '><div ';
        print ' class="vote-good"' if $row->{'voteu'} >= $row->{'voted'} * $config{'votes_color'} + $config{'votes_color'};
        print ' class="vote-bad"'  if $row->{'voted'} >= $row->{'voteu'} * $config{'votes_color'} + $config{'votes_color'};
        print '>';
        if ( $config{'allow_vote'} ) {
          print lang('vote') unless $config{'no_vote_word'};
          print '[<a  title="', lang('rate up'), '" href="#" onclick="rvote(\'', $config{'root_url'},
            '?view=http-vote&amp;vote=u', '&amp;url=', encode_url( join_url($row) ), $work{'uparam'},
            '\',this);return false;"><span class="vote-up">', lang('uarr'), ( $row->{'voteu'} or '' ), '</span></a>:<a title="',
            lang('rate down'), '" href="#" onclick="rvote(\'', $config{'root_url'}, '?view=http-vote&amp;vote=d', '&amp;url=',
            encode_url( join_url($row) ), $work{'uparam'}, '\', this);return false;"><span class="vote-down">', lang('darr'),
            ( $row->{'voted'} or '' ), '</span></a>] ';
        }
        if ( $config{'action_prot_func'}{ $row->{'prot'} } ) { $config{'action_prot_func'}{ $row->{'prot'} }->($row); }
        #         print ("preaction( p=$row->{'prot'})", Dumper $config{'action'});
        if (
          length $row->{'prot'}
          # or $row->{'magnet'}
          )
        {
          for my $prt ( sort keys %{ $config{'action'} } ) {
            #          print ("action($prt, h=$row->{'host'})"),
            next if !$row->{'host'};    # and !$row->{'magnet'};
            my ( $extname, $actname ) = ( $row->{'full'}, $prt );
            my $origextname = $extname;
            $actname =~ s/^\-//;
            for my $w ( sort keys %{ $config{'action'}{$prt} } ) {
              if ( !$w or $config{'action'}{$prt}{$w}->( \$extname, $row ) ) {
     #                print(Dumper({ prt=>$prt,'go' => $extname, 'save' => $origextname, 'actname' => lang($actname), %$row })),
                print $config{'redirector'}
                  ->( { 'go' => $extname, 'save' => $origextname, 'actname' => lang($actname), %$row } )
                  unless $extname =~ /\/{2,}\s*$/;
                last;
              }
            }
          }
          #          print ("action_func($_)"),
        }
        $config{'action_func'}{$_}->($row)
          for sort grep { ref $config{'action_func'}{$_} eq 'CODE' and !hconfig( 'no_' . $_, $row->{'host'}, $row->{'prot'} ) }
          keys %{ $config{'action_func'} };
        #}
        print " [$row->{'dl'}]" if $row->{'dl'} and !$config{'no_dl'};
#print " $row->{'ip'}" if $row->{'ip'} and $row->{'ip'} ne $row->{'host'} and length($row->{'path'})<=1 and !length($row->{'name'})and !hconfig('no_ip', %$row);
        print '</div></td><td>';
        $row->{'live'} = $row->{'scan'} if $row->{'live'} and $row->{'live'} < $row->{'scan'};
        $work{'head'}{$_} += ( $row->{$_} =~ /^\s*\d+\s*$/ ? $row->{$_} : ( $row->{$_} =~ /\S/ ? 1 : 0 ) )
          #,      print("$_ = $work{'head'}{$_};")
          for (
          grep( ( $config{'sql'}{'table'}{$table}{$_}{'row'} and $row->{$_} ), keys %{ $config{'sql'}{'table'}{$table} } ) );
        my $timcol = ( time() + $config{'timediff'} - $row->{'live'} );
        #printlog('dev', 'timecol1',hconfig('period', %$row)),
        $timcol += $config{'online_minutes'} * 60
          if $row->{'prot'} ne 'dchub' and $row->{'scan'} < hconfig( 'period', %$row ) - 86400 * 2;
        #printlog('dev', 'timecol2'),
        $timcol = $config{'online_minutes'} * 120 if $timcol > $config{'online_minutes'} * 120;
        $timcol /= ( ( ( $config{'online_minutes'} * 120 ) / 255 ) );
        $timcol = sprintf( '%02X%02X%02X', $timcol, 255 - $timcol, 0 );
        if ( !$config{'w3_org_valid'} and !$config{'no_online'} and $row->{'live'} and $timcol ) {
          $timcol = "bgcolor=\"#$timcol\"";
        } else {
          $timcol = '';
        }
        if ( $row->{'size'} ) {
          if ( $row->{'prot'} eq 'http' and $row->{'size'} == 1 ) { print lang('?') unless $config{'no_unk_word'}; }
          else {
            psmisc::printu mylink(
              psmisc::human( 'size', $row->{'size'} ),
              { 'size' => $row->{'size'}, 'size_mode' => 'e' },
              {
                'title' => "$row->{'size'} bytes",
                ( $row->{'size'} == $param->{'size'} ? ( 'class' => 'hilight1' ) : () ),
                ( $row->{'files'}                    ? ( 'href'  => undef )      : () )
              },
              { 'destroy' => $config{'destroy_link_size'}, }
            );
          }
        } else {
          print lang('dir') unless $config{'no_dir_word'};
        }
        unless ( $config{'no_files_dirs'} ) {
          print ' (' if $row->{'files'} or $row->{'dirs'};
          print psmisc::human( 'number', $row->{'files'} ), ' ', lang('files') if $row->{'files'};
          print ' ', psmisc::human( 'number', $row->{'dirs'} ), ' ', lang('dirs') if $row->{'dirs'};
          print ')' if $row->{'files'} or $row->{'dirs'};
        }
        print '</td><td>';
        print mylink(
          psmisc::human( 'time_period', time() + $config{'timediff'} - $row->{'time'} ),
          { 'time' => $row->{'time'} },
          {
            ( $row->{'time'} == $param->{'time'} ? ( 'class' => 'hilight1' ) : () ),
            'title' => psmisc::human( 'date_time', $row->{'time'} ) . ( $param->{'utime'} ? ' ' . $row->{'time'} : '' )
          },
          { 'destroy' => $config{'destroy_link_time'} }
          ),
          if $row->{'time'};
        print '</td><td>';
        print "stem[$row->{'stem'}]" if $param->{'debug'} && $row->{'stem'};
        print "mount -t nfs $row->{'host'}:$row->{'path'}/$row->{'name'} /mnt<br/>"
          if $row->{'prot'} eq 'nfs' and $row->{'mountpoint'};
        print out_bold( destroy_html( $row->{'desc'} ), $work{'search_str'} . $work{'bold_desc'} ), '</td>';
        print '<td><a href="' . $work{'sparam'} . '&amp;tiger=' . $row->{'tiger'} . '">',
          out_bold( destroy_html( $row->{'tiger'} ), $work{'search_str'} . $work{'bold_tiger'} ), '</a></td>'
          if $work{'show_tiger'};
        psmisc::printu(
          '<td class="td-scan" ',
          $timcol,
          ' id="pinger',
          $row->{'n'},
          '">', ( (
              ( !$config{'no_row_scan'} and !$config{'no_online'} and $row->{'live'} ) ? mylink(
                psmisc::human( 'time_period', int( time() ) + $config{'timediff'} - $row->{'live'} ) || 0,
                undef, {
                  'title' => lang( 'live', undef, undef, ' ' )
                    . psmisc::human( 'date_time', $row->{'live'} - $config{'timediff'} ),
                  'href' => undef,
                },
                ) : ' '
            ),
            ' ', (
              ( !$config{'no_row_scan'} and $row->{'scan'} ) ? mylink(
                psmisc::human( 'time_period', int( time() ) + $config{'timediff'} - $row->{'scan'} ) || 0,
                undef, {
                  'title' => lang( 'scan', undef, undef, ' ' )
                    . psmisc::human( 'date_time', $row->{'scan'} - $config{'timediff'} ),
                  'href' => undef,
                },
                ) : ' '
            ),
            ' ', (
              ( !$config{'no_row_scan'} and $row->{'added'} ) ? mylink(
                psmisc::human( 'time_period', int( time() ) + $config{'timediff'} - $row->{'added'} ) || 0,
                undef, {
                  'title' => lang( 'added', undef, undef, ' ' )
                    . psmisc::human( 'date_time', $row->{'added'} - $config{'timediff'} ),
                  'href' => undef,
                },
                ) : ' '
            ),
          ),
          '</td>'
        );

        if (  $config{'allow_pinger'}
          and $row->{'host'}
          and ( 1 or ( $row->{'hostscan'} and $row->{'live'} ) )
          and ( $row->{'hostscan'} < time() - $config{'ping_interval'} )
          and ( $row->{'live'} < time() - $config{'ping_interval'} ) )
        {
          $work{'pinger'}{ join_url( { %$row, %{ $config{'clear_file'} } } ) }{'row'} ||= $row;
          push @{ $work{'pinger'}{ join_url( { %$row, %{ $config{'clear_file'} } } ) }{'n'} }, $row->{'n'};
        }
        print '</tr>';
        $work{'img_must'}{ $row->{'n'} } = $row if $row->{'can_show'} and $row->{'show'};
        print '<tr class="result_play" ><td ', nameid( 'res_play' . $row->{'n'} ), ' ', (' style="display:none;" '),
          ' colspan="', ( $work{'show_tiger'} ? 8 : 7 ), '">', '</td></tr>'
          if $row->{'can_show'};
        return if $fparam->{'no_stat'};
        ++$stat{'files'}{$_} for grep { $row->{'ext'} =~ /$config{'ext'}{$_}{'to'}/i } keys %{ $config{'ext'} };
        $stat{'onpage'}{$_} += $row->{$_}
          for grep { $row->{$_} =~ /^\d+$/ and $row->{$_} and $config{'sql'}{'table'}{$table}{$_}{'allow_count'} } keys %$row;
        ++$stat{'onpage'}{'files'};
      };
      $config{'out'}{'html'}{'result_foot'} = sub {
        my ( $param, $table ) = @_;
        print '<tr><td colspan="7"/></tr>';
        if ( !$config{'no_onpage'} and keys %{ $stat{'onpage'} } ) {
          print '<tr><td/>',
            ( ( $config{'no_split_link'} or $param->{'no_result_header'} ) ? ('<td/>') : ( '<td>', lang('on page'), '</td>' ) ),
            $stat{'onpage'}{'dl'} ? ( '<td class="result-foot">[', $stat{'onpage'}{'dl'}, ']</td>' ) : '<td/>',
            '<td class="result-foot">';
          psmisc::printu psmisc::human( 'size', $stat{'onpage'}{'size'} ) if $stat{'onpage'}{'size'};
          unless ( $config{'no_files_dirs'} ) {
            print ' (' if $stat{'onpage'}{'files'} or $stat{'onpage'}{'dirs'};
            print psmisc::human( 'number', $stat{'onpage'}{'files'} ), ' ', lang('files') if $stat{'onpage'}{'files'};
            print ' ', psmisc::human( 'number', $stat{'onpage'}{'dirs'} ), ' ', lang('dirs') if $stat{'onpage'}{'dirs'};
            print ')' if $stat{'onpage'}{'files'} or $stat{'onpage'}{'dirs'};
          }
          print '</td><td/><td/>', ( $work{'show_tiger'} ? '<td/>' : '' ), '<td/></tr>';
        }
        if ( keys %{ $static{'db'}->{'stat'}{'found'} }
          and !( keys %{ $stat{'onpage'} } and $stat{'onpage'}{'files'} == $stat{'found'}{'files'} ) )
        {
          print '<tr><td/>',
            ( ( $config{'no_split_link'} or $param->{'no_result_header'} ) ? ('<td/>') : ( '<td>', lang('total'), '</td>' ) ),
            ( $static{'db'}->{'stat'}{'found'}{'dl'}
            ? ( '<td class="result-foot">[', $static{'db'}->{'stat'}{'found'}{'dl'}, ']</td>' )
            : ('<td/>') ), '<td class="result-foot">';
          print psmisc::human( 'size', $static{'db'}->{'stat'}{'found'}{'size'} ) if $static{'db'}->{'stat'}{'found'}{'size'};
          print ' (' if $static{'db'}->{'stat'}{'found'}{'files'} or $static{'db'}->{'stat'}{'found'}{'dirs'};
          print psmisc::human( 'number', $static{'db'}->{'stat'}{'found'}{'files'} ), ' ', lang('files')
            if $static{'db'}->{'stat'}{'found'}{'files'};
          print ' ', psmisc::human( 'number', $static{'db'}->{'stat'}{'found'}{'dirs'} ), ' ', lang('dirs')
            if $static{'db'}->{'stat'}{'found'}{'dirs'};
          print ')' if $static{'db'}->{'stat'}{'found'}{'files'} or $static{'db'}->{'stat'}{'found'}{'dirs'};
          print '</td><td/><td/>', ( $work{'show_tiger'} ? '<td/>' : '' ), '<td/></tr>';
        }
        #!!!TODO line to ALL results
        map { $work{'head'}{$_} = 0 } qw(prot user pass host port dcuser path name ext param) if $config{'no_split_link'};
        #dmp grep {$config{'sql'}{'table'}{$table}{$_}{'row'} }  keys %{$config{'sql'}{'table'}{$table}||{}};
        print '</table>';
        part( 'result_foot_hide', $param, $table );
        print $config{'jscript_open'};
        local $_ = 0;
        for my $n ( sort { $a <=> $b } keys %{ $work{'img_must'} } ) {
          my $pause = max( $config{'img_show_pause'}, $config{ 'img_show_pause_' . $work{'img_must'}{$n}->{'prot'} } );
          print 'showtimeout[', $n, '] = setTimeout("' if $pause;
          print toggle_play( $work{'img_must'}{$n} );
          print '", ', $_, ')' if $pause;
          print ';';
          $_ += $pause;
        }
        print $config{'jscript_close'};
      };
      $config{'out'}{'html'}{'result-report'} = sub {
        my ( $param, $table ) = @_;
        if ( !$config{'no_playlist_link'} and $stat{'files'}{'media'} ) {
          print lang('playlist'), ' ',
            mylink(
            lang('current') . '(' . $stat{'files'}{'media'} . ')', {
              get_param_hash( $param, ( 'view', 'prot', @{ $config{'skip_from_link'} } ) ),
              'view'   => 'm3u',
              'prot'   => 'file|http',
              'online' => $config{'online_minutes'}
            },
            undef,
            { 'destroy' => $config{'destroy_link_view'} }
            ),
            ' ';
          print mylink(
            lang('all'), {
              get_param_hash( $param, ( 'view', 'prot', 'on_page', @{ $config{'skip_from_link'} } ) ),
              'view'    => 'm3u',
              'prot'    => 'file|http',
              'online'  => $config{'online_minutes'},
              'on_page' => $config{'maxplaylist'}
            },
            undef,
            { 'destroy' => $config{'destroy_link_view'} }
            )
            if $param->{'page'} > 1
              or $static{'db'}->{'dbirows'} >= $static{'db'}->{'limit'};
          print '<br/>';
        }
        print lang('found'), ' '
          if $stat{'found_time'} > 0
            or $static{'db'}->{'founded'} > 0
            or $static{'db'}->{'stat'}{'found'}{'size'} > 0
            or !$stat{'results'};
        print " $static{'db'}->{'founded'} ", lang('files'), ' ' if $static{'db'}->{'founded'} > 0 or !$stat{'results'};
        psmisc::printu " $static{'db'}->{'stat'}{'found'}{'size'} ", lang('bytes'),
          ( $static{'db'}->{'stat'}{'found'}{'size'} > 1000
          ? ' (' . psmisc::human( 'size', $static{'db'}->{'stat'}{'found'}{'size'} ) . ')'
          : ' ' )
          if $static{'db'}->{'stat'}{'found'}{'size'} > 0;
        print ' ', lang('in'), ' ', psmisc::human( 'time_period', $stat{'found_time'} ), ' ' if $stat{'found_time'} > 0;
        #print "zzzzz[$stat{'found_time'}]";
        print ', ', lang('showed'), ' ',
          ( $static{'db'}->{'dbirows'} ? $static{'db'}->{'limit_offset'} + 1 : $static{'db'}->{'limit_offset'} ) . '-'
          . ( $static{'db'}->{'founded'} > $static{'db'}->{'limit_offset'} + $static{'db'}->{'limit'}
          ? $static{'db'}->{'limit_offset'} + $static{'db'}->{'limit'}
          : ( $static{'db'}->{'founded'} or $static{'db'}->{'limit_offset'} + $static{'db'}->{'dbirows'} ) )
          . ( $static{'db'}->{'page'}
          ? ' (' . lang('page') . " $static{'db'}->{'page'} " . lang('from') . " $static{'db'}->{'page_last'})"
          : '' )
          if $static{'db'}->{'page_last'} > 1;
        print '<br/>';

=no
        dmp {
          'current' => $static{'db'}->{'page'},    #$stat{'page'},
          #'buttonsb'      => $config{'gotopage_bb'},
          #'buttonsa'      => $config{'gotopage_ba'},
          'total'     => $static{'db'}->{'founded'},
          'actual'    => $static{'db'}->{'dbirows'},
          'size'      => $static{'db'}->{'limit'},
          'last'      => $static{'db'}->{'page_last'},
          'total_max' => $static{'db'}->{'founded_max'},
        };
=cut

        part(
          'gotopage',
          $param, $table, {
            'current' => $static{'db'}->{'page'},    #$stat{'page'},
            #'buttonsb'      => $config{'gotopage_bb'},
            #'buttonsa'      => $config{'gotopage_ba'},
            'total'     => $static{'db'}->{'founded'},
            'actual'    => $static{'db'}->{'dbirows'},
            'size'      => $static{'db'}->{'limit'},
            'last'      => $static{'db'}->{'page_last'},
            'total_max' => $static{'db'}->{'founded_max'},
          }
        );
        part( 'viewas', $param, $table ) if $static{'db'}->{'founded'};
        if ( ( $static{'db'}->{'dbirows'} > 0 or $static{'db'}->{'founded'} > 0 ) and $static{'db'}->{'limit'} > 0 ) { }
        else {
          psmisc::printall( \$config{'no_results_insert'}, $param );
          print $config{'jscript_open'}, q{toggleview('form-in-founded');}, $config{'jscript_close'} if $param->{'page'} <= 1;
        }
        if ( $config{'proisk_ru_link'} ) {
          my %tparam;
          map { $tparam{$_} = $param->{$_} } grep $param->{$_}, qw(name ext size q tiger time);
          local $config{'allow_rewrite_q'} = 0;
          print '<div class="search-internet">',
            #Dumper(\%tparam),
            mylink(
            lang('search in internet'),
            #{ %tparam, 'codepage' => $work{'codepage'} },
            \%tparam, undef, { 'base' => 'http://proisk.ru/' }
            ),
            '</div>'
            if keys %tparam;
        }
      };
      #TO DO
      $config{'out'}{''}{'stat-get'} ||= sub {
        my ( $param, $table, $fparam ) = @_;
        #QUOTES
        #res
        sql_query_line(
"SELECT SUM(files) AS files, SUM(dirs) AS dirs, SUM(size) AS size, SUM(dl) AS dl, count(*) AS servers FROM `$config{'sql_table_prefix'}$config{'sql_tresource'}` WHERE `files` > '0'"
        );
        #onl
        $static{'db'}->line(
          "SELECT SUM($config{'sql_table_prefix'}$config{'sql_tresource'}.files) AS files, 
SUM($config{'sql_table_prefix'}$config{'sql_tresource'}.dirs) AS dirs, 
SUM($config{'sql_table_prefix'}$config{'sql_tresource'}.size) AS size, count(*) AS servers 
FROM `$config{'sql_table_prefix'}$config{'sql_tresource'}` 
LEFT JOIN `$config{'sql_table_prefix'}$config{'sql_thost'}` USING (host) 
WHERE $config{'sql_table_prefix'}$config{'sql_tresource'}.files > '0' 
AND $config{'sql_table_prefix'}$config{'sql_thost'}.time > '"
            . ( int( time() ) + $config{'timediff'} - $config{'online_minutes'} * 60 ) . "'"
        ) if !$config{'no_online'};
        #ran
        $static{'db'}
          ->line("SELECT SUM(alive) AS alive, SUM(size) AS ips FROM `$config{'sql_table_prefix'}$config{'sql_tranges'}`");
      };
      $config{'out'}{'html'}{'main-stat'} ||= sub {
        my ($param) = @_;
        my ( $tq,  $rq,  $vq )  = $static{'db'}->quotes();
        my ( $res, $onl, $ran ) = (
          $static{'db'}->line(
                "SELECT SUM($rq"
              . "files$rq) AS $rq"
              . "files$rq, SUM($rq"
              . "dirs$rq) AS $rq"
              . "dirs$rq, SUM($rq"
              . "size$rq) AS $rq"
              . "size$rq, SUM($rq"
              . "dl$rq) AS $rq"
              . "dl$rq, COUNT(*) AS $rq"
              . "servers$rq FROM $tq$config{'sql_table_prefix'}$config{'sql_tresource'}$tq WHERE $rq"
              . "files$rq > $vq" . "0$vq"
          ), (
            !$config{'no_online'}
            ? $static{'db'}->line(
                  "SELECT SUM($tq"
                . "$config{'sql_table_prefix'}$config{'sql_tresource'}$tq.$rq"
                . "files$rq) AS $rq"
                . "files$rq, SUM($tq"
                . "$config{'sql_table_prefix'}$config{'sql_tresource'}$tq.$rq"
                . "dirs$rq) AS $rq"
                . "dirs$rq, SUM($tq"
                . "$config{'sql_table_prefix'}$config{'sql_tresource'}$tq.$rq"
                . "size$rq) AS $rq"
                . "size$rq, COUNT(*) AS $rq"
                . "servers$rq FROM $tq$config{'sql_table_prefix'}$config{'sql_tresource'}$tq LEFT JOIN $tq$config{'sql_table_prefix'}$config{'sql_thost'}$tq USING ($tq"
                . "host$tq"
                . ( $config{'sql'}{'table'}{ $config{'sql_thost'} }{'dcuser'} ? ", $tq" . "dcuser$tq" : '' )
                . ") WHERE $tq"
                . "$config{'sql_table_prefix'}$config{'sql_tresource'}$tq.$rq"
                . "files$rq > $vq"
                . "0$vq AND $tq$config{'sql_table_prefix'}$config{'sql_thost'}$tq.$rq"
                . "time$rq > $vq"
                . ( int( time() ) + $config{'timediff'} - $config{'online_minutes'} * 60 )
                . $vq
              )
            : {}
          ),
          $static{'db'}->line(
                "SELECT SUM($rq"
              . "alive$rq) AS $rq"
              . "alive$rq, SUM($rq"
              . "size$rq) AS $rq"
              . "ips$rq FROM $tq$config{'sql_table_prefix'}$config{'sql_tranges'}$tq"
          )
        );
        print '<table class="top-table">';
        psmisc::printu '<tr><td></td><td class="stat-header">', lang('files'), '</td><td class="stat-header">', lang('dirs'),
          '</td><td class="stat-header">', lang('bytes'), '</td></tr>', '<tr class="result-1"><td>', lang('found'), '</td><td>',
          psmisc::human( 'number', $res->{'files'} ), '</td>', '<td>', psmisc::human( 'number', $res->{'dirs'} ), '</td>',
          '<td>', psmisc::human( 'size', $res->{'size'} ), '</td></tr>'
          if $res
            and %$res
            and grep( $_, values %$res );
        print '<tr class="result-1"><td>', lang('online'), '</td><td>', psmisc::human( 'number', $onl->{'files'} ), '</td>',
          '<td>', psmisc::human( 'number', $onl->{'dirs'} ), '</td>', '<td>', psmisc::human( 'size', $onl->{'size'} ),
          '</td></tr>'
          if !$config{'no_online'}
            and %$onl
            and ( $onl->{'size'} or $onl->{'files'} or $onl->{'dirs'} );
        print '<tr><td></td><td class="stat-header">', lang('ips'), '</td><td class="stat-header">', lang('alive'),
          '</td><td class="stat-header">', lang('servers'), '</td></tr>', '<tr class="result-0"><td>', lang('scanned'),
          '</td><td>', psmisc::human( 'number', $ran->{'ips'} ), '</td>', '<td>', psmisc::human( 'number', $ran->{'alive'} ),
          '</td>', '<td>', psmisc::human( 'number', $stat{'servers'} = $res->{'servers'} ), '</td></tr>'
          if $res->{'servers'}
            or ( %$ran and grep( $_, values %$ran ) );
        print '<tr class="result-1"><td>', lang('dl'), '</td><td>', psmisc::human( 'number', $res->{'dl'} ), '</td></tr>'
          if $res->{'dl'};
        print '<tr><td></td><td class="stat-header">', lang('total'), '</td><td class="stat-header">', lang('yesterday'),
          '</td><td class="stat-header">', lang('today'), '</td></tr>', '<tr class="result-0"><td>', lang('hits'), '</td><td>',
          psmisc::human( 'number', $work{'counter'}{'total'} ), '</td>', '<td>',
          psmisc::human( 'number', $work{'counter'}{'pday'} ),  '</td>', '<td>',
          psmisc::human( 'number', $work{'counter'}{'day'} ),   '</td></tr>'
          if keys %{ $work{'counter'} };
        print '</table>';
      };
      $config{'out'}{'html'}{'examples'} ||= sub {
        my ( $param, $table ) = @_;
        print lang('search examples'), ':<br/>',
          mylink(
          lang('servers'), { 'path' => 'EMPTY', 'order' => 'host', 'size' => '0' },
          undef, { 'destroy' => $config{'destroy_link_sort'} }
          ),
          ' ';
        print ' (',
          mylink( lang('online'),
          { 'path' => 'EMPTY', 'order' => 'host', 'size' => '0', 'online' => $config{'online_minutes'} },
          undef, { 'destroy' => $config{'destroy_link_sort'} } ),
          ') '
          if !$config{'no_online'};
        print ' ', $config{'sel_sep'}, ' ',
          mylink(
          lang('net view'), { 'path' => '/', 'order' => 'host', 'size' => '0' },
          undef, { 'destroy' => $config{'destroy_link_sort'} }
          ),
          ' '
          unless $config{'in_inet'};
        print ' (',
          mylink( lang('online'), { 'path' => '/', 'order' => 'host', 'size' => '0', 'online' => $config{'online_minutes'} },
          undef, { 'destroy' => $config{'destroy_link_sort'} } ),
          ') '
          if !$config{'no_online'} and !$config{'in_inet'};
        unless ( $config{'scanner'}{'http'}{'disabled'} ) {
          print ' ', $config{'sel_sep'},
            mylink( lang('sites'), { 'prot' => 'http', 'path' => 'EMPTY', 'order' => 'host', 'size' => '0' },
            undef, { 'destroy' => $config{'destroy_link_sort'} } ),
            ' ';
          print ' (',
            mylink( lang('online'),
            { 'prot' => 'http', 'path' => 'EMPTY', 'order' => 'host', 'size' => '0', 'online' => $config{'online_minutes'} },
            undef, { 'destroy' => $config{'destroy_link_sort'} } ),
            ') '
            if !$config{'no_online'};
        }
        if ( %{ $config{'sql'}{'table'}{$table}{'dcuser'} or {} } and !$config{'scanner'}{'dchub'}{'disabled'} ) {
          print ' ', $config{'sel_sep'},
            mylink( lang('dchubs'), { 'prot' => 'dchub', 'dcuser' => 'EMPTY', 'path' => 'EMPTY' },
            undef, { 'destroy' => $config{'destroy_link_sort'} } ),
            ' ',
            mylink( lang('users'), { 'prot' => 'dchub', 'dcuser' => '!EMPTY', 'path' => 'EMPTY' },
            undef, { 'destroy' => $config{'destroy_link_sort'} } ),
            ' ';
        }
        print '<br/>';
        if ( exists $config{'sql'}{'table'}{$table}{'time'} ) {
          print lang('last'),
            map( {
              ( ' ', mylink( $_, $config{'preset'}{'soft'}{$_}{'set'}, undef, { 'destroy' => $config{'destroy_link_sort'} } ) )
            } sort keys %{ $config{'preset'}{'soft'} } ),
            '<br/>'
            unless $config{'in_inet'};
          if ( !$config{'in_inet'} ) {
            print lang('new'), ' ';
            print ' ',
              mylink(
              lang($_), { 'order_mode' => '!', 'order' => 'time', 'ext' => ':' . $_, },
              undef, { 'destroy' => $config{'destroy_link_sort'} }
              )
              for ( grep { $config{'ext'}{$_}{'to'} and !$config{'ext'}{$_}{'skip_what'} }
              sort { $config{'ext'}{$a}{'order'} <=> $config{'ext'}{$b}{'order'} } keys %{ $config{'ext'} } );
            print '<br/>';
          }
        }
        if ( !$config{'no_listen_music'} and $config{'client_local'} ) {
          print lang('listen music'), ' ',
            mylink(
            lang('net'), {
              'prot'    => 'file|http',
              'ext'     => ':audio',
              'host'    => $config{'client_ip_a'} . '.' . $config{'client_ip_b'} . '.' . $config{'client_ip_c'} . '.*',
              'online'  => '80',
              'view'    => 'm3u',
              'on_page' => '100000'
            },
            undef,
            { 'destroy' => $config{'destroy_link_view'} }
            ),
            ' ',
            mylink(
            lang('my'), {
              'prot' => 'file|http',
              'ext'  => ':audio',
              'host' => $config{'client_ip_a'} . '.'
                . $config{'client_ip_b'} . '.'
                . $config{'client_ip_c'} . '.'
                . $config{'client_ip_d'},
              'online'  => '80',
              'view'    => 'm3u',
              'on_page' => '100000'
            },
            undef,
            { 'destroy' => $config{'destroy_link_view'} }
            );
        }
      };
      #$config{'out'}{'html'}{'footer'} ||= sub {
      $config{'html_footer_aft'} ||= sub {
        my ($param) = @_;
        #part( 'footer-stat', $param );
        #DO NOT REMOVE THE FOLLOWING COPYRIGHT LINE. YOU'RE NOT ALLOWED TO REMOVE NOR EDIT THIS.
        #PLAY FAIR AND SUPPORT THE DEVELOPMENT, PLEASE!
        print '[<a href="http://proisk.ru">proisk.ru</a>] 2003-',
          ( split /\D+/, '$Date: 2012-05-20 23:06:33 +0400 (Sun, 20 May 2012) $' )[1],
          ' <a href="http://pro.setun.net/search/">PRO-search ',
          ( $config{'version'} or 'r' . ( split( ' ', '$Revision: 4797 $' ) )[1] ), '</a>';
      };
      $config{'out'}{'html'}{'foot'} ||= sub {
        my ( $param, $table ) = @_;
        print( '<div ', nameid('help-popup'), ' class="help-popup" style="display: none;"></div>' ),
          cache_file_js( undef, ( 'help.js', 'help_' . $work{'lang'} . '.js' ) )
          if $config{'help_dev'};
        if ( $config{'ajax'} ) {
          cache_file_js( undef, ('JsHttpRequest.js') );
          print $config{'jscript_open'};
          print qq{
var loading = 0;

function update_loading() {
  gid('loading').innerHTML = loading ? 'load '+ loading : '' ;

}

function dosubmit(q) {
    if (q == null) 
     q =  {
        'form': document.getElementById('searchform')//,
//        'q': document.getElementById('text').value
        };
//    alert(document.getElementById('searchform'));
    ++loading;
    update_loading()
    JsHttpRequest.query(
        'index.cgi', 
        q,
        function(responseJS, responseText) {
         --loading;
         update_loading()
//alert(loading);

//           document.getElementById('search').innerHTML = responseText;
//alert(responseJS);
                for (var k in responseJS) {
                    var v = responseJS[k];
//                   alert (k + '='+v);
                    if (!document.getElementById(k) || !v) continue;
                    document.getElementById(k).innerHTML = v;
                }

/*            document.getElementById('ajaxresult').innerHTML = 
                '<b>MD5("'+responseJS.q+'")</b> = ' +
                '"' + responseJS.md5 + '"<br> ';
            // Write debug information too (output become responseText).
            document.getElementById('ajaxdebug').innerHTML = responseText;
*/        },
        false , // do not disable caching
        ''
    );
//alert(JsHttpRequest.query.PENDING);
//alert(loading);
}
}
            ;
          print $config{'jscript_close'};
          print
'<div id="ajaxresult" style="border:1px solid #000; padding:2px"></div><div id="ajaxdebug" style="border:1px dashed red; padding:2px"></div>'
            if $param->{'debug'};
        } else {
          print $config{'jscript_open'};
          print "function dosubmit(q) { disable_form(gid('searchform')); gid('searchform').submit(); }";
          print $config{'jscript_close'};
        }
        unless ( $config{'in_inet'} ) {
          %_ = ( 'host' => $config{'client_ip'}, 'time' => int( time() ), 'scan' => int( time() ) );
          $_->update( $config{'sql_thost'}, undef, \%_, $static{'db'}->true() ) for @{ $static{'dbs_up'} };
        }
        for my $host ( sort { $work{'pinger'}{$a}{'n'}[0] <=> $work{'pinger'}{$b}{'n'}[0] } keys %{ $work{'pinger'} } ) {
          psmisc::flush();
          printlog( 'web', 'pinging', $host );
          my $color = pinger( $work{'pinger'}{$host}{'row'} );
          next unless $color;
          print $config{'jscript_open'};
          print 'gid("pinger', $_, '").bgColor = ' for ( @{ $work{'pinger'}{$host}{'n'} } );
          print '"', $color, '";', $config{'jscript_close'};
        }
        print '</body></html>';
      };
      $config{'out'}{'html'}{'top'} ||= sub {
        my ( $paramorig, $table, $fparam ) = @_;
        my $param;
        %$param = %$paramorig;
        $table  = $config{'sql_tresource'};
        #$param->{'on_page'} =
        #$param->{'limit'} =
        local $static{'db'}->{'limit'} = check_int( $param->{'results'}, 1, $config{'top_res_max'}, $config{'top_res'} );
        #printlog("TOPcalc[($param->{'on_page'} = $param->{'results'}, 1, $config{'top_res_max'}, $config{'top_res'} )]");
        $param->{'order'} ||= 'size';
        $param->{'order_mode'} = '!' if !defined( $param->{'order_mode'} ) and $param->{'order'} eq 'size';
        local $static{'db'}->{'disable_slow'} = 0;
        local $config{'allow_null_count'} = 1;
        $param = {
          %$param,
          'size'      => $config{'res_list_min_size'},
          'size_mode' => 'g',
          #'files1' => 1, 'files1_mode' => 'g',
          'path' => 'EMPTY',
        };
        #my $where = $static{'db'}->where( $param, undef, $table );
        #my $top = $static{'db'}->query( $static{'db'}->select_body( $where, $param, $table ) ) if
        my $top =
          $static{'db'}->query( $static{'db'}->select_body( $static{'db'}->where( $param, undef, $table ), $param, $table ) )
          if $static{'db'}->{'limit'};
        #$param->{'on_page'} ;
        #$param->{'limit'};
        #printlog('dev','4111:',$static{'db'}, Dumper($top) );
        #printlog('4112:',$static{'db'}->{'limit'} );
        if ( $static{'db'}->{'limit'} and scalar @$top >= 1 and keys %{ $top->[0] || {} } ) {
          print( $static{'db'}->{'limit'} != 100
            ? (
              '[',
              lang('top'),
              '100 ',
              map( ( mylink( lang($_), { 'show' => 'top', 'results' => '100', 'order' => $_, 'order_mode' => '!' } ), ' ' ),
                ( qw(size dl), ( $config{'allow_vote'} ? ('voteu') : () ) ) ),
              '] '
              )
            : ''
          );
          print lang('top'), ' ', $static{'db'}->{'limit'}, ' ', lang('resources'), ': ', '<br/>';
          local $param->{'no_result_header'} = 1 unless $param->{'show'} eq 'top';
          part( 'result_head', $param, $table, undef, { 'no_cont' => 1 } );
          for my $row (@$top) {
            undef $row->{'time'};
            delete( $row->{$_} ) for grep( ( !%{ $config{'sql'}{'table'}{$table}{$_} or {} } ), qw(user pass port) );
            $row->{'full'} = join_url($row);
            part( 'result_string_pre',  $param, $table, $row, { 'no_cont' => 1 } );
            part( 'result_string',      $param, $table, $row, { 'no_cont' => 1 } );
            part( 'result_string_post', $param, $table, $row, { 'no_cont' => 1 } );
          }
          part( 'result_foot', $param, $table, undef, { 'no_cont' => 1 } );
        }
        #calc_count( $param, $table ),
        $static{'db'}->calc_count( $param, $table ), part(
          'gotopage',
          $param, undef, {
            'current' => $param->{'page'},
            #'buttonsb'      => $config{'gotopage_bb'},
            'buttonsa' => 1,
            'total'    => $static{'db'}->{'founded'},
            'actual'   => $static{'db'}->{'dbirows'},
            'size'     => $static{'db'}->{'limit'},
            'last'     => $static{'db'}->{'page_last'}
          }
        ) unless $fparam->{'no_gotopage'};
      };
      $config{'out'}{'html'}{'main-top-stat'} = sub {
        my ( $param, $table, $fparam ) = @_;
        if ( $stat{servers} == 1 ) {
          local $config{'no_result-report'} = 1;
          part(
            'search', {
              #'prot'=> $config{'local_prot'}, 'host'=> $config{'local_host'} ,
              'path' => '/'
            },
            $config{'sql_tfile'},
          );
        } else {
          part( 'top', $param, undef, $fparam );
        }
      };
      $config{'out'}{'html'}{'add'} ||= sub {
        return unless $config{'allow_add'};
        my ($param) = @_;
        print 'Examples: ';
        print
'ftp://123.456.789.12 ftp://xxx@123.456.789.12 ftp://video:xxx@123.456.789.12 ftp://video:xxx@123.456.789.12:666 ftp://123.456.789.12:666 ftp://cool.warez.net '
          unless $config{'scanner'}{'ftp'}{'disabled'};
        print 'file://10.20.30.40 ' unless $config{'scanner'}{'file'}{'disabled'};
        print 'http://20.30.10.20 ' unless $config{'scanner'}{'http'}{'disabled'};
        my ( $userp, $ping, $port );
        eval { $ping = Net::Ping->new( 'tcp', $config{'ping_timeout'} ); };

        if ($ping) {
          $ping->service_check(1);
          for my $prot (
            grep {
              $config{'scanner'}{$_}{'port'}
                and !$config{'scanner'}{$_}{'disabled'}
                and $config{'scanner'}{$_}{'pingable'}
                and !$config{'scanner'}{$_}{'no_web_add'}
            } keys %{ $config{'scanner'} }
            )
          {
            $port = $config{'scanner'}{$prot}{'port'};
            $ping->{'port_num'} = $port;
            $userp .= $prot . '://' . $config{'client_ip'} . ' ' if local $_ = $ping->ping( $config{'client_ip'} );
            printlog( 'dbg', 'pinged', $prot, '://', $config{'client_ip'}, ':', $port, ' = ', $_ );
          }
        }
        print '<br/><form method="', $config{'form_method'}, '" action="', $config{'root_url'},
          '" id="add"><div class="add-form">', '<input type="hidden" name="show" value="add_submit" />';
        my ($prot) =
          $config{'scanner'}{'ftp'}{'disabled'}
          ? grep( !$config{'scanner'}{$_}{'disabled'}, keys %{ $config{'scanner'} } )
          : 'ftp';
        $prot .= '://' if $prot;
        $userp ||= $prot . $config{'client_ip'};
        print '<input type="text" name="url" title="', lang('url'), '" size="80" value="', $userp, '" /> ',
          '<input type="submit" name="add" value="', lang('add'), '" /> '
          if $prot;
        print '<input type="submit" name="rescan" value="', lang('rescan'), '" /> ' if $prot and $config{'allow_web_rescan'};
        print '</div></form>';
      };
      $config{'out'}{'html'}{'add_submit'} ||= sub {
        print("Error1<br/>"), return unless $config{'allow_add'};
        my ($param) = @_;
        local $config{'sql'}{'database'} = $config{'sql_base_wup'};
        $param->{'rescan'} = '' unless $config{'allow_web_rescan'};
        for my $url ( grep $_, split /\s+/, $param->{'url'} ) {
          print '[', $url, ']: ';
          print( 'Error1: ', lang('wrong symbols'), '<br/>' ), next unless $url =~ m|^[a-zA-Z0-9\-.:@/*_]+$| and $url =~ /\./;
          my %url = ( split_url($url), %{ $config{'clear_file'} } );
          print( 'Error2: ', lang('wrong host'), '<br/>' ), next unless $url{'host'} =~ /\w/i;
          my ( $ip, $iperr ) = name_to_ip( $url{'host'} );
          print( 'Error3: ', lang('not ip'), '<br/>' ), next if $iperr;
          print( 'Error4: ', lang('wrong host ip'), '<br/>' ), next unless $ip =~ /$config{'web_add_mask'}/i;
          $url{'host'} = normalize_ip( $url{'host'} )
            if !$config{'web_add_only_ip'}
              and hconfig( 'host_by_name_norm', $url{'host'} )
              and !( $config{'norm_skip_host'} and $url{'host'} =~ /$config{'norm_skip_host'}/i );
          $url{'host'} = $ip if $config{'web_add_only_ip'};
          print 'ip:', $ip, ' ' if $ip ne $url{'host'};
          print ' = ', $_, ' ' if ( local $_ = join_url( \%url ) ) ne $url;
          print( 'Error5: ', lang('you can rescan only'), " $url{'prot'}://", $config{'client_ip'}, '<br/>' ), next
            if ( $param->{'rescan'} and !$config{'web_rescan_other'} and ( $config{'client_ip'} ne $ip ) );
          print( 'Error6: ', lang('unknown protocol'), '<br/>' ), next unless defined $config{'scanner'}{ $url{'prot'} };
          print( 'Error7: ', lang('unable to add protocol'), '<br/>' ), next
            if $config{'scanner'}{ $url{'prot'} }{'no_web_add'};
          print( 'Error8: ', lang('disabled protocol'), '<br/>' ), next if $config{'scanner'}{ $url{'prot'} }{'disabled'};
          $url{'port'} = undef if $url{'port'} == $config{'scanner'}{ $url{'prot'} }{'port'};
          print( 'Error9: ', lang('wrong your host'), '<br/>' ), next
            unless $config{'client_ip'} =~ /$config{'web_adder_mask'}/;
          $url{'path'} = '';
          %_ = ( %url, 'host' => full_host( \%url ) );

          if ( $param->{'rescan'} ) {
            my $table = $config{'sql_tresource'};
            local $static{'db'}->{'limit'} = 1;
            my $res =
              $static{'db'}->line( $static{'db'}->select( $static{'db'}->where( \%url, undef, $table ), undef, $table ) );
            print(
              'Error8: ',
              lang('please wait'),
              ' ',
              psmisc::human(
                'time_period',
                $res->{'scan'}
                ? $config{'web_rescan_min_time'} - int( time() ) + $res->{'scan'}
                : $config{'web_rescan_min_time'}
              ),
              '<br/>'
              ),
              next
              if %{$res} and ( !$res->{'scan'} or time() - $res->{'scan'} < $config{'web_rescan_min_time'} );
          }
          my %up = ( 'added' => int( time() ), ( $param->{'rescan'} ? ( 'scan' => 0, 'time' => 0 ) : () ) );
          $_->update( $config{'sql_tresource'}, undef, { %_, %up } ) for @{ $static{'dbs_up'} };
          $up{'time'} = $up{'scan'} = int( time() );
          $_->update( $config{'sql_thost'}, undef, { %_, %up } ) for @{ $static{'dbs_up'} };
          print ' ok.<br/>';
        }
      };
      $config{'out'}{'m3u'}{'result_string'} ||= sub {
        my ( $param, $table, $row ) = @_;
        $row->{'desc'} =~ s/^\s*\[(\d+)s\]\s+//;
        my $s = ( $1 or -1 );
        print "#EXTINF:$s,$row->{'desc'}\n" if $row->{'desc'};
        $row->{'full'} =~ tr/\//\\/ if $row->{'full'} =~ s/^file://;
        print "$row->{'full'}\n";
      };
      $config{'out'}{'text'}{'result_string'} = sub {
        my ( $param, $table, $row ) = @_;
        part( 'tiger', $param, $table, $row ) if $row->{'tiger'};
        for my $field (qw(full size time desc)) {
          print "\t";
          part( $field, $param, $table, $row );
        }
      };
      $config{'out'}{'xml'}{'result_string'} ||= sub {
        my ( $param, $table, $row ) = @_;
        print "\t<file>\n", "\t\t<link>", get_param_url_str( $param, ['view'] ), '#n', ( ++$work{'rssn'} ), "</link>\n",
          "\t\t<num>", $work{'rssn'}, "</num>\n";
        for my $r ( sort keys %$row ) {
          if ( $r =~ /^(?:full|path|name|ext|desc)$/i ) { $row->{$r} =~ s/\&/\&amp;/g; }
          print "\t\t<", $r, '>', $row->{$r}, '</', $r, ">\n" if $row->{$r};
        }
        print "\t</file>\n",;
      };
      $config{'out'}{'http-redirect'}{'hide'}        ||= 1;
      $config{'out'}{'http-redirect'}{'http-header'} ||= $config{'out'}{'html'}{'http-header'};
      $config{'out'}{'http-redirect'}{'head'}        ||= sub { redirect_update(@_); };
      $config{'out'}{'http-vote'}{'hide'}            ||= 1;
      $config{'out'}{'http-vote'}{'http-header'}     ||= $config{'out'}{'html'}{'http-header'};
      $config{'out'}{'http-vote'}{'head'}            ||= sub {
        my ( $param, $table ) = @_;
        return unless $config{'client_ip'};
        local $config{'sql'}{'database'} = $config{'sql_base_wup'};
        print '<html><head>', '</head><body> Thanks';
        print '</body></html>';
        my $vote;
        if    ( $param->{'vote'} eq 'u' ) { $vote = 'voteu'; }
        elsif ( $param->{'vote'} eq 'd' ) { $vote = 'voted'; }
        else                              { return; }
        my %url = split_url( $param->{'url'} );
        return unless $url{'host'};
        $url{'host'} = full_host( \%url );

        for my $t ( grep $config{'sql'}{'table'}{$_}{$vote}, ( $config{'sql_thost'}, $config{'sql_tfile'} ) ) {
          $_->update(
            $t, undef, \%url,
            "`lastip` != '$config{'client_ip'}'",
            "`lastip` = '$config{'client_ip'}', `$vote` = `$vote` + '1'"
          ) for @{ $static{'dbs_up'} };
        }
        print $config{'jscript_open'}, 'window.close();', $config{'jscript_close'} unless $param->{'debug'};
      };
      $config{'out'}{'proxy'}{'hide'}           ||= 1;
      $config{'out'}{'proxy'}{'no-http-header'} ||= 1;
      $config{'out'}{'proxy'}{'head'}           ||= sub {
        my ( $param, $table ) = @_;
        return unless $config{'allow_proxy'};
        my ( $fileok, $log );
        local $_;
        $log .= 'Error1: ' . lang('wrong your ip') . "<br\n/>", goto PROXYEX
          unless $config{'client_ip'} =~ /$config{'proxy_client_mask'}/i;
        my %url = split_url( $param->{'url'} );
        %url = ( %url, split_url( $url{'host'} ) );
        $log .= "Error1: wrong hostname<br\n/>", goto PROXYEX unless $url{'host'};
        my ( $ip, $iperr ) = name_to_ip( $url{'host'} );
        $log .= 'Error2: ' . lang('not ip') . " $url{'host'} : $iperr <br\n/>", goto PROXYEX if $iperr;
        $log .= 'Error3: ' . lang('wrong host ip') . "<br\n/>", goto PROXYEX unless $ip =~ /$config{'proxy_server_mask'}/i;
        my ( $ftp, $dc );

        if ( $url{'prot'} eq 'dchub' ) {
          #use lib
          #$config{'root_path'}
          #. './Net::DirectConnect';
          #use Net::DirectConnect::clihub;
          #our $root_path;
          eval "use Net::DirectConnect::clihub;";    #use lib '$root_path./dcppp';
          print( "Content-type: text/html\n\n", " lib load error o=$0 sf=$ENV{'SCRIPT_FILENAME'}; ", $@ ), return if $@;
          $param->{'url'} =~ m|^(?:dchub\://)?(.+?)(?:\:(\d+))?/(.+?)/(.+)$|;
          my ( $user_nick, $file ) = ( $3, $4 );
          $dc = Net::DirectConnect::clihub->new(
            'host' => $1,
            ( $2 ? ( 'port' => $2 ) : () ),
            #'myip' => $config{'myip'},
            'Nick' => 'PSdcpppDl' . int( rand(100) ),
            'log'  => sub { $log .= join( '', @_ ) . "\n"; },
            %{ $config{'fine'}{'dchub'} }, %{ $config{'fine'}{ $1 . ( $2 ? ':' . $2 : '' ) } },
          );
          $dc->{'handler'}{'openfile_bef'} = sub {
            $fileok = 1;
            print "Content-type: application/x-download\n", "Content-Disposition:attachment",
              map( "; $_=$param->{$_}", grep $param->{$_}, qw(filename) ), "\n", "Content-Length: $param->{'size'}\n", "\n"
              if defined( $ENV{'SERVER_PORT'} );
          };
          $dc->get( $user_nick, $file, '-' );
          $dc->work();
        } elsif ( $url{'prot'} eq 'ftp' ) {
          eval q{ use Net::FTP; };    # xamps windows mod_perl bug
          $ftp = Net::FTP->new( $url{'host'} ) or $log .= "Cannot connect to $url{'host'}: $@<br\n/>", goto PROXYEX;
          #1;    } or goto PROXYEX;
          $ftp->login( $config{'anonymous_user'}, $config{'anonymous_pass'} )
            or $log .= "Cannot login: " . $ftp->message . "<br\n/>", goto PROXYEX;
          my $file = join_url( { map { $_ => $url{$_} } qw(path name ext) } );
          my $size = $ftp->size($file) or $log .= "size failed: " . $ftp->message . "<br\n/>", goto PROXYEX;
          $param->{'size'} = $size;
          $param->{'filename'} ||= join_url( { map { $_ => $url{$_} } qw(name ext) } );
          $fileok = 1;
          print "Content-type: application/x-download\n", "Content-Disposition:attachment",
            map( "; $_=$param->{$_}", grep $param->{$_}, qw(filename) ), "\n", "Content-Length: $param->{'size'}\n",
            #"Content-Description: $param->{'url'}\n",
            "\n" if defined( $ENV{'SERVER_PORT'} );
          $ftp->binary();
          $ftp->get( $file, *STDOUT ) or $log .= "get failed: " . $ftp->message . "<br\n/>", $fileok = 0, goto PROXYEX;
        } elsif ( $url{'prot'} eq 'file' ) {
          my $file = $param->{'url'};
          $param->{'filename'} ||= join_url( { map { $_ => $url{$_} } qw(name ext) } );
          binmode(STDOUT);
          if ( $config{'system'} eq 'win' ) {
            #print $config{'out'}{'html'}{'http-header'};
            $file =~ s|^file:||i;
            #$file =~ tr|/|\\|;
            #$file =~ s|\\|\\\\|g;
            my $size = -s ($file) or $log .= "size failed: [$file]" . "<br\n/>", goto PROXYEX;
            $param->{'size'} = $size;
            open( FDL, '<', $file ) or $log .= "open failed: [$file] " . $! . "<br\n/>", goto PROXYEX;
            binmode(FDL);
        #open(FDL, '<', "type $file|") or $log .= "open failed: [$file]" .$!. "<br\n/>", goto PROXYEX;
        #my $h = openproc("$config{'starter'} type \"$file\" |") or $log .= "open failed: [$file]" .$!. "<br\n/>", goto PROXYEX;
        #my $h = openproc("$config{'starter'} echo \"$file\" |") or $log .= "open failed: [$file]" .$!. "<br\n/>", goto PROXYEX;
        #print "[$file:]";
            $fileok = 1;
            print "Content-type: application/x-download\n", "Content-Disposition:attachment",
              map( "; $_=$param->{$_}", grep $param->{$_}, qw(filename) ), "\n", "Content-Length: $param->{'size'}\n", "\n"
              if defined( $ENV{'SERVER_PORT'} );
            #local $_;
            print while (<FDL>);
            #while( <FDL>) {
            #while( <$h>) {
            #print "line:[$_]";
            #print;
            #print <FDL>;
            #}
            close(FDL);
            #close($h);
          } else {
            #$config{'scanner'}{'file'}{'get'} ||= sub {
            #return $_[0] if $config{'system'} =~ /win/i;
            my ($service);
            my $prot = 'file';
            $file =~ s/\|\>\<\"//g;
            ( $service, $file ) = $file =~ /^(?:\S+:)?(\/*[^\/]+\/[^\/]+)\/(.+)$/;
            #$save = encode_url( $prot . ':' . $service . '/' . $file, $config{'encode_url_file_mask'} );
            $file =~ s/\/+/\\\\/g;
            #$file =~ s/\'/\'\'/g;       bbb u u ggg   ' symol in file name
            #$file =~ s/\'/\\\'\\\'/g;   bbb u u ggg       !!!TODO test with "
            #$file =~ s/\'/\\\'/g;       bbb uuu ggg
            #return ''
            $log .= "wrong filename: [$file]" . "<br\n/>", goto PROXYEX if $file =~ /\'/;
            my ($host) = $service =~ /([\w.]+)/;
            $file = cp_trans( hconfig( 'cp_db', $host, $prot ), hconfig( 'cp_res', $host, $prot ), $file );
            #$save = hconfig('tmpdir') . hconfig( 'slash_sys', $host ) . $save;
            #return $save
            #if -e $save and -M $save < hconfig( 'get_file_cache_timeout', $host );
            shelldata( $file, $service );
            my $h = openproc(
"$config{'starter'} $config{'smbclient'} $config{'smb_opt'} $config{'get_opt'} -c 'get \"$file\" -' \"$service\" |",
            ) or $log .= "open failed: [$service $file]" . $! . "<br\n/>", goto PROXYEX;
            $fileok = 1;
            print "Content-type: application/x-download\n", "Content-Disposition:attachment",
              map( "; $_=$param->{$_}", grep $param->{$_}, qw(filename) ), "\n",
              #"Content-Length: $param->{'size'}\n",
              "\n" if defined( $ENV{'SERVER_PORT'} );
            print while (<$h>);
            close($h);
            #return $save;
            #};
          }
        } else {
          $log .= "unknown proto: " . $url{'prot'} . "<br\n/>", goto PROXYEX;
        }
      PROXYEX: $dc->destroy() if $dc;
        $ftp->quit() if $ftp;
#print( ( defined( $ENV{'SERVER_PORT'} ) ? $config{'out'}{'html'}{'http-header'} : '' ), "sorry, error<br\n/>", $log )    unless $fileok;
        unless ($fileok) {
          $config{'out'}{''}{'error'} = sub { print( "<br/>sorry, error:<br\n/>", $log ); };
          local $config{'view'} = 'html';
          part( 'run', { 'show' => 'error' }, undef, undef, { 'no_cont' => 1 } );
        }
      };
    }
  );
  #devlog('dev', 'index begined', Dumper(\%config,\%static));
}

sub page {
  print("Content-type: text/html\n\n"), return if $ENV{"REQUEST_METHOD"} eq "HEAD";
  init();
  psweb::part( 'run', $param, $config{'sql_tfile'}, undef, { 'no_cont' => 1 } );
  if ( 0 and $param->{'debug'} ) {
    #print "<br\n><br\n><h1>INC:</h1><br\n>";		for (sort keys %INC)	{ print "$_ = $INC{$_}<br\n>"; } # debug #
    dmp "<pre><br\n><br\n><h1>param:</h1><br\n><br\n><![CDATA[", Dumper($param), ']]>';
    dmp "<pre><br\n><br\n><h1>work:</h1><br\n><br\n><![CDATA[", Dumper( \%work ), ']]>';
    #dmp "<pre><br\n><br\n><h1>stat:</h1><br\n><br\n><![CDATA[", Dumper (\%stat),']]>'	 ;
    dmp "<pre><br\n><br\n><h1>config:</h1><br\n><br\n><![CDATA[", Dumper( \%config ), ']]>';
    dmp "<pre><br\n><br\n><h1>ENV:</h1><br\n><br\n><![CDATA[",    Dumper( \%ENV ),    ']]>';
    #print "<br\n><br\n><h1>static:</h1><br\n><br\n><![CDATA[", Dumper (\%static),']]>'	 ;
  }
}
page() unless $config{'module_index'};
#exit;
1;
